<?php
	///////////////////////////////////////////////////////////////////////////////
	// Copyright  2003 Michael Bird. All Rights Reserved                        //
	//                                                                           //
	// This file is part of Help Center Live.                                    //
	//                                                                           //
	// Help Center Live is free software; you can redistribute it and/or modify  //
	// it under the terms of the GNU General Public License as published by      //
	// the Free Software Foundation; either version 2 of the License, or         //
	// (at your option) any later version.                                       //
	//                                                                           //
	// Help Center Live is distributed in the hope that it will be useful,       //
	// but WITHOUT ANY WARRANTY; without even the implied warranty of            //
	// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             //
	// GNU General Public License for more details.                              //
	//                                                                           //
	// You should have received a copy of the GNU General Public License         //
	// along with Help Center Live; if not, write to the Free Software           //
	// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA //
	///////////////////////////////////////////////////////////////////////////////



	include_once("../inc/config.php");
	include_once("../inc/database.php");



	// Update timer so visitor does not timeout

	$IMAGE_uid = $_GET["chatid"];
	$IMAGE_page = rawurldecode($_GET["page"]);
	$IMAGE_referrer = rawurldecode($_GET["refurl"]);
	$IMAGE_ip = $_SERVER["REMOTE_ADDR"];
	$IMAGE_hostname = @gethostbyaddr($IMAGE_ip);
	$IMAGE_time = time();
	if($IMAGE_referrer == ""){
		$IMAGE_referrer = "Unknown";
	}

	// Update visitor footprints


	// Has the visitor been here before but is on a new visit
	$IMAGE_newv = $IMAGE_time - $TRAFFIC_newvisit;
	$result = DATABASE_query("SELECT * FROM ".$DB_prefix."traffic WHERE chatid='$IMAGE_uid' AND time<$IMAGE_newv");
	if($get = DATABASE_fetch($result)){

		$IMAGE_visits = $get["visits"] + 1;

		DATABASE_query("UPDATE ".$DB_prefix."traffic SET referrer='$IMAGE_referrer', start='$IMAGE_time', visits='$IMAGE_visits' WHERE chatid='$IMAGE_uid'");
		DATABASE_query("DELETE FROM ".$DB_prefix."footprints WHERE chatid='$IMAGE_uid'");
		DATABASE_query("INSERT INTO ".$DB_prefix."footprints (chatid,page,time) VALUES ('$IMAGE_uid','$IMAGE_page','$IMAGE_time')");

		$sound = DATABASE_query("SELECT * FROM ".$DB_prefix."operators");
		while($fetch = DATABASE_fetch($sound)){
			$SOUND_operator = $fetch["operator"];
			$SOUND_time = time();
			DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','newvisitor','$SOUND_time')");
		}

	}



	// If this is a first visit
	$result = DATABASE_query("SELECT * FROM ".$DB_prefix."traffic WHERE chatid='$IMAGE_uid'");
	if(!DATABASE_fetch($result)){
		$sound = DATABASE_query("SELECT * FROM ".$DB_prefix."operators");
		while($fetch = DATABASE_fetch($sound)){
			$SOUND_operator = $fetch["operator"];
			$SOUND_time = time();
			DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','newvisitor','$SOUND_time')");
		}
		DATABASE_query("INSERT INTO ".$DB_prefix."traffic (chatid,ip,hostname,referrer,time,requests,visits,start) VALUES ('$IMAGE_uid','$IMAGE_ip','$IMAGE_hostname','$IMAGE_referrer','$IMAGE_time','0','1','$IMAGE_time')");
	}

	// Check to see if visitor is on a new page
	$result = DATABASE_query("SELECT * FROM ".$DB_prefix."footprints WHERE chatid='$IMAGE_uid' ORDER BY id DESC LIMIT 1");
	if($get = DATABASE_fetch($result)){
		$IMAGE_lastpage = $get["page"];
		if($IMAGE_lastpage !== $IMAGE_page){
			if(isset($_GET["footprint"])){
				DATABASE_query("INSERT INTO ".$DB_prefix."footprints (chatid,page,time) VALUES ('$IMAGE_uid','$IMAGE_page','$IMAGE_time')");
			}
			$sound = DATABASE_query("SELECT * FROM ".$DB_prefix."operators");
			while($fetch = DATABASE_fetch($sound)){
				$SOUND_operator = $fetch["operator"];
				$SOUND_time = time();
				if(isset($_GET["footprint"])){
					DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','newpage','$SOUND_time')");
				}
				$result_hotpage = DATABASE_query("SELECT * FROM ".$DB_prefix."hotpages WHERE page='$IMAGE_page'");
				if(DATABASE_fetch($result_hotpage)){
					if(isset($_GET["footprint"])){
						DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','hotpage','$SOUND_time')");
					}
				}
			}
		}
	}else{
		if(isset($_GET["footprint"])){
			DATABASE_query("INSERT INTO ".$DB_prefix."footprints (chatid,page,time) VALUES ('$IMAGE_uid','$IMAGE_page','$IMAGE_time')");
		}
		$sound = DATABASE_query("SELECT * FROM ".$DB_prefix."operators");
		while($fetch = DATABASE_fetch($sound)){
			$SOUND_operator = $fetch["operator"];
			$SOUND_time = time();
			if(isset($_GET["footprint"])){
				DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','newpage','$SOUND_time')");
			}
			$result_hotpage = DATABASE_query("SELECT * FROM ".$DB_prefix."hotpages WHERE page='$IMAGE_page'");
			if(DATABASE_fetch($result_hotpage)){
				if(isset($_GET["footprint"])){
					DATABASE_query("INSERT INTO ".$DB_prefix."sounds (operator,sound,time) VALUES ('$SOUND_operator','hotpage','$SOUND_time')");
				}
			}
		}
	}


	// Update the traffic time
	DATABASE_query("UPDATE ".$DB_prefix."traffic SET time='$IMAGE_time' WHERE chatid='$IMAGE_uid'");


	// Update the system so visitor does not timeout

	// The reason why the visitors time is updated in both system and traffic is because
	// the session needs to be deleted when the visitor times out so they are removed from
	// the traffic monitor however the time in the traffic table just needs to stop as it
	// will be used in the statistics

	$result = DATABASE_query("SELECT * FROM ".$DB_prefix."system WHERE chatid='$IMAGE_uid'");
	if(DATABASE_fetch($result)){
		DATABASE_query("UPDATE ".$DB_prefix."system SET time='$IMAGE_time' WHERE chatid='$IMAGE_uid'");
	}else{
		$result_system = DATABASE_query("SELECT * FROM ".$DB_prefix."operators");
		while($fetch = DATABASE_fetch($result_system)){
			$IMAGE_operator = $fetch["operator"];
			DATABASE_query("INSERT INTO ".$DB_prefix."system (operator,chatid,time) VALUES ('$IMAGE_operator','$IMAGE_uid','$IMAGE_time')");
		}
	}

	// Check to see if anyone has initiated a chat with this visitor

	$result = DATABASE_query("SELECT * FROM ".$DB_prefix."session WHERE chatid='$IMAGE_uid' AND alert='initiate'");
	if(DATABASE_fetch($result)){
		$IMAGE_type = $URL_maindir."/lh/images/pix_two.gif";
	}else{
		$IMAGE_type = $URL_maindir."/lh/images/pix_one.gif";
	}


		Header("Content-type: image/gif");
		readfile($IMAGE_type);
?>