<?php # $Id: comment.php,v 1.24 2003/10/13 12:15:08 garvinhicking Exp $

session_start();
include_once('serendipity_config.inc.php');

if (isset($serendipity['GET']['delete'], $serendipity['GET']['entry'], $serendipity['GET']['type'])) {
    serendipity_deleteComment($serendipity['GET']['delete'], $serendipity['GET']['entry'], $serendipity['GET']['type']);
}

if (isset($serendipity['GET']['switch'], $serendipity['GET']['entry'])) {
    serendipity_allowCommentsToggle($serendipity['GET']['entry'], $serendipity['GET']['switch']);
}

/* It's time to finally check if we need to remember the entered information,
   the reason we are doing this up here, is because we want to send cookie-headers */
if ( isset($serendipity['POST']['remember']) ) {
    $details['url']      = $serendipity['POST']['url'];
    $details['name']     = $serendipity['POST']['name'];
    $details['email']    = $serendipity['POST']['email'];
    $details['remember'] = 'checked';
    serendipity_rememberCommentDetails($details);
} elseif ( isset($serendipity['POST']['comment']) ) {
    serendipity_forgetCommentDetails();
}


if (!($type = @$_REQUEST['type'])) {
    $type = 'normal';
}

if ($type == 'trackback') {
    $uri = $_SERVER['REQUEST_URI'];
    if (isset($_REQUEST['entry_id'])) {
        $id = $_REQUEST['entry_id'];
    } else if (preg_match('@\/(\d+)$@', $uri, $matches)) {
        $id = $matches[1];
    }

    if (add_trackback($id, $_REQUEST['title'], $_REQUEST['url'],
                      $_REQUEST['blog_name'], $_REQUEST['excerpt'])) {
        report_trackback_success();
    } else {
        report_trackback_failure();
    }
} else if ($type == 'pingback') {
    if(add_pingback($_REQUEST['entry_id'], $HTTP_RAW_POST_DATA)) {
        report_pingback_success();
    } else {
        report_pingback_failure();
    }
} else {
    $id = $serendipity['GET']['entry_id'];

    if ($serendipity['XHTML11']) {
        echo '<?xml version="1.0" encoding="iso-8859-1" ?>' . "\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
    "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<?php
    }
?>
<html<?php echo ($serendipity['XHTML11'] ? ' xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" dir="ltr"' : ''); ?>>
<head>
    <title><?php echo COMMENTS; ?></title>
    <link rel="stylesheet" type="text/css" href="<?php echo $serendipity['serendipityHTTPPath']; ?>serendipity.css.php?mode=comments" />
</head>
<body>

<?php
    if (!isset($serendipity['POST']['comment'])) {
        if ($serendipity['GET']['type'] == 'trackbacks') {
            $tbu = $serendipity['baseURL'] . 'comment.php?type=trackback&amp;entry_id=' . $serendipity['GET']['entry_id'];
            $query = 'SELECT title FROM ' . $serendipity['dbPrefix'] . 'entries WHERE id = ' . $serendipity['GET']['entry_id'];
            $entry = serendipity_db_query($query);
            $entry =  $serendipity['baseURL']
                   . 'archives/'
                   . $serendipity['GET']['entry_id']
                   . '_' . serendipity_makeFilename($entry[0]['title']) . '.html';
?>
    <div class="serendipity_commentsTitle"><?php echo TRACKBACKS; ?></div><br />
    <dl>
        <dt><b><?php echo TRACKBACK_SPECIFIC; ?>:</b><br /></dt>
        <dd><a href="<?php echo $tbu; ?>"><?php echo $tbu; ?></a><br /></dd>

        <dt><b><?php echo DIRECT_LINK; ?>:</b><br /></dt>
        <dd><a href="<?php echo $entry; ?>"><?php echo $entry; ?></a></dd>
    </dl>
    <?php serendipity_printTrackbacks(serendipity_fetchTrackbacks($id)); ?>
<?php
        } else {
?>
    <div class="serendipity_commentsTitle"><?php echo COMMENTS; ?></div>
<?php
            $query = "SELECT allow_comments FROM {$serendipity['dbPrefix']}entries WHERE id = '$id'";
            $ca    = serendipity_db_query($query, true);

            serendipity_printComments(serendipity_fetchComments($id), (isset($ca['allow_comments']) ? $ca['allow_comments'] : true));

            if ($ca['allow_comments'] === true || $ca['allow_comments'] == 'true' || !is_array($ca)) {
?>

    <div class="serendipity_commentsTitle"><?php echo ADD_COMMENT; ?></div>
<?php
                serendipity_displayCommentForm($id);
            }
        }
    } else {
        $comment['url']       = $serendipity['POST']['url'];
        $comment['comment']   = trim($serendipity['POST']['comment']);
        $comment['name']      = $serendipity['POST']['name'];
        $comment['email']     = $serendipity['POST']['email'];
        $comment['subscribe'] = $serendipity['POST']['subscribe'];
        if ( !empty($comment['comment']) ) {
            if (serendipity_saveComment($serendipity['POST']['entry_id'], $comment, 'NORMAL')) {
                printf(
                  COMMENT_ADDED,

                  '<a href="' . $_SERVER['HTTP_REFERER'] . '">',
                  '</a>',
                  '<a href="#" onclick="self.close()">',
                  '</a>'
                );
            } else {
                printf(
                  COMMENT_NOT_ADDED,

                  '<a href="' . $_SERVER['HTTP_REFERER'] . '">',
                  '</a>',
                  '<a href="#" onclick="self.close()">',
                  '</a>'
                );
            }
        } else {
            printf(
              EMPTY_COMMENT,

              '<a href="#" onclick="history.go(-1)">',
              '</a>'
            );
        }
    }
?>
</body>
</html>
<?php
}
/* vim: set sts=4 ts=4 expandtab : */
?>
