<?php # $Id: serendipity_admin_plugins.inc.php,v 1.14 2003/10/13 12:02:10 garvinhicking Exp $

if (IN_serendipity !== true) {
    die ('Don\'t hack!');
}
session_start();

include_once 'serendipity_plugin_api.php';
include_once 'serendipity_sidebar_items.php';

function placement_box($name, $val)
{
    static $opts = array(
                    'left'  => LEFT,
                    'right' => RIGHT,
                    'hide'  => HIDDEN
        );

    $x = "\n<select name=\"$name\">\n";
    foreach ($opts as $k => $v) {
        $x .= "    <option value=\"$k\"" . ($k == $val ? ' selected="selected"' : '') . ">$v</option>\n";
    }
    return $x . "</select>\n";
}

if (isset($_GET['serendipity']['plugin_to_move']) && isset($_GET['submit'])) {
    $plugins = serendipity_plugin_api::enum_plugins();

    /* Renumber the sort order to be certain that one actually exists
        Also look for the one we're going to move */
    $idx_to_move = -1;
    for($idx = 0; $idx < count($plugins); $idx++) {
        $plugins[$idx]['sort_order'] = $idx;

        if ($plugins[$idx]['name'] == $_GET['serendipity']['plugin_to_move']) {
            $idx_to_move = $idx;
        }
    }

    /* If idx_to_move is still -1 then we never found it (shouldn't happen under normal conditions)
        Also make sure the swaping idx is around */
    if ($idx_to_move >= 0 && (($_GET['submit'] == 'move down' && $idx_to_move < (count($plugins)-1)) || ($_GET['submit'] == 'move up' && $idx_to_move > 0))) {

        /* Swap the one were moving with the one that's in the spot we're moving to */
        $tmp = $plugins[$idx_to_move]['sort_order'];
        $plugins[$idx_to_move]['sort_order'] = (int)$plugins[$idx_to_move + ($_GET['submit'] == 'move down' ? 1 : -1)]['sort_order'];
        $plugins[$idx_to_move + ($_GET['submit'] == 'move down' ? 1 : -1)]['sort_order'] = (int)$tmp;

        /* Update table */
        foreach($plugins as $plugin) {
            $key = serendipity_db_escape_string($plugin['name']);
            serendipity_db_query("UPDATE {$serendipity['dbPrefix']}plugins SET sort_order = {$plugin['sort_order']} WHERE name='$key'");
        }
    }

    /* TODO: Moving The first Right oriented plugin up,
            or the last left oriented plugin down
            should not be displayed to the user as an option.
            It's a behavior which really has no meaning. */
}

if (isset($_GET['serendipity']['plugin_to_conf'])) {
    /* configure a specific instance */
    $plugin =& serendipity_plugin_api::load_plugin($_GET['serendipity']['plugin_to_conf']);

    $bag  = new serendipity_property_bag;
    $plugin->introspect($bag);
    $name = htmlentities($bag->get('name'));
    $desc = htmlentities($bag->get('description'));

    $config_names = $bag->get('configuration');

    if (isset($_POST['SAVECONF'])) {
        /* enum properties and set their values */

        foreach ($config_names as $config_item) {
            $cbag = new serendipity_property_bag;
            if ($plugin->introspect_config_item($config_item, $cbag)) {
                $plugin->set_config($config_item, $_POST['serendipity']['plugin'][$config_item]);
            }
        }
    }
?>
<form method="post" name="serendipityPluginConfigure">
    <table cellpadding="5">
        <tr>
            <th><?php echo NAME; ?></th>
            <td><?php echo $name; ?></td>
        </tr>

        <tr>
            <th><?php echo DESCRIPTION; ?></th>
            <td><?php echo $desc; ?></td>
        </tr>
    </table>

    <table border="0" cellspacing="5" cellpadding="5">
<?php
    foreach ($config_names as $config_item) {
        $cbag = new serendipity_property_bag;
        $plugin->introspect_config_item($config_item, $cbag);

        $cname   = htmlentities($cbag->get('name'));
        $cdesc   = htmlentities($cbag->get('description'));
        $value   = $plugin->get_config($config_item);
        $hvalue  = (isset($_POST['serendipity']['plugin'][$config_item]) ? htmlentities($_POST['serendipity']['plugin'][$config_item]) : htmlentities($value));
        $radio   = array();
        $select  = array();

        switch ($cbag->get('type')) {
            case 'seperator':
?>
        <tr>
            <td colspan="2"><hr noshade="noshade" size="1" /></td>
        </tr>
<?php
                break;

            case 'select':
                $select = $plugin->select_values;
?>
        <tr>
            <td style="vertical-align: top"><?php echo $cname; ?></td>
            <td style="vertical-align: top">
                <div>
                    <select name="serendipity[plugin][<?php echo $config_item; ?>]">
<?php
                foreach($select AS $select_value => $select_desc) {
                    $id = htmlspecialchars($config_item . $select_value);
?>
                        <option value="<?php echo $select_value; ?>" <?php echo ($select_value == $hvalue ? 'selected="selected"' : ''); ?> title="<?php echo htmlentities($select_desc); ?>" />
                            <?php echo htmlentities($select_desc); ?>
                        </option>
<?php
                }
?>
                    </select>
                </div>
<?php
                if ($cdesc != '') {
?>
                <br /><span style="color: #bbbbbb">//&nbsp;<?php echo $cdesc; ?></span>
<?php
                }
?>
            </td>
        </tr>
<?php
                break;

            case 'boolean':
                $radio['value'][] = 'true';
                $radio['desc'][]  = YES;

                $radio['value'][] = 'false';
                $radio['desc'][]  = NO;

           case 'radio':
                if (!count($radio) > 0) {
                    $radio = $cbag->get('radio');
                }

                $per_row = $cbag->get('radio_per_row');
                if (empty($per_row)) {
                    $per_row = 2;
                }
?>
        <tr>
            <td style="vertical-align: top"><?php echo $cname; ?></td>
            <td style="vertical-align: top">
<?php
                $counter = 0;
                foreach($radio['value'] AS $radio_index => $radio_value) {
                    $id = htmlspecialchars($config_item . $radio_value);
                    $counter++;
                    if ($counter == 1) {
?>
                <div>
<?php
                    }
?>
                    <input type="radio" id="serendipity_plugin_<?php echo $id; ?>" name="serendipity[plugin][<?php echo $config_item; ?>]" value="<?php echo $radio_value; ?>" <?php echo ($radio_value == $hvalue ? 'checked="checked"' : ''); ?> title="<?php echo htmlentities($radio['desc'][$radio_index]); ?>" />
                        <label for="serendipity_plugin_<?php echo $id; ?>"><?php echo htmlentities($radio['desc'][$radio_index]); ?></label>
<?php
                    if ($counter == $per_row) {
                        $counter = 0;
?>
                </div>
<?php
                    }
                }

                if ($cdesc != '') {
?>
                <br /><span style="color: #bbbbbb">//&nbsp;<?php echo $cdesc; ?></span>
<?php
                }
?>
            </td>
        </tr>
<?php
                break;

            case 'string':
?>
        <tr>
            <td><?php echo $cname; ?></td>
            <td>
                <div>
                    <input type="text" name="serendipity[plugin][<?php echo $config_item; ?>]" value="<?php echo $hvalue; ?>" />&nbsp;<span style="color: #bbbbbb">//&nbsp;<?php echo $cdesc; ?></span>
                </div>
            </td>
        </tr>
<?php
                break;

            case 'html':
?>
        <tr>
            <td colspan="2">
                <?php echo $cname; ?>&nbsp;<span style="color: #bbbbbb">//&nbsp;<?php echo $cdesc; ?></span>
            </td>
        </tr>

        <tr>
            <td colspan="2">
                <div>
                    <textarea name="serendipity[plugin][<?php echo $config_item; ?>]" rows="20" cols="80"><?php echo $hvalue; ?></textarea>
                </div>
            </td>
        </tr>
<?php
                serendipity_emit_htmlarea_code("document.forms['serendipityPluginConfigure']['serendipity[plugin][$config_item]']");
                break;
        }
    }
?>
    </table>

    <div>
        <input type="submit" name="SAVECONF" value="<?php echo SAVE; ?>" />
    </div>
</form>
<?php
} else {
    /* show general plugin list */

    if (isset($_POST['SAVE']) && isset($_POST['serendipity']['placement'])) {
        foreach ($_POST['serendipity']['placement'] as $plugin_name => $placement) {
            serendipity_plugin_api::update_plugin_placement(
                addslashes($plugin_name),
                addslashes($placement)
            );
        }
    }

    if (isset($_POST['NEW']) && $_POST['serendipity']['plugin_to_add'] != '0') {
        $inst = serendipity_plugin_api::create_plugin_instance($_POST['serendipity']['plugin_to_add']);
        /* TODO: redirect to configuration for that instance */
    }

    if (isset($_POST['REMOVE'])) {
        foreach ($_POST['serendipity']['plugin_to_remove'] as $key) {
            serendipity_plugin_api::remove_plugin_instance($key);
        }
    }

    /* list of classes for creating instances */
    $classes = serendipity_plugin_api::enum_plugin_classes();
?>
<form action="?serendipity[adminModule]=plugins" method="post">
    <div>
        <select name="serendipity[plugin_to_add]">
            <option value="0">[ <?php echo SELECT_A_PLUGIN_TO_ADD; ?> ]</option>
<?php
    foreach ($classes as $class_name) {
        $plugin =& serendipity_plugin_api::load_plugin($class_name);

            /* query for its name, description and configuration data */
            $bag = new serendipity_property_bag;
            $plugin->introspect($bag);

            $name = $bag->get('name');
            $desc = $bag->get('description');
?>
            <option value="<?php echo $class_name; ?>"><?php echo $name . ' - ' . $desc; ?></option>
<?php
    }
?>
        </select>
        <input name="NEW" value="<?php echo ADD_PLUGIN; ?>" type="submit" />
        <br />
        <br />

        <table border="0" cellpadding="5" cellspacing="0">
            <tr>
                <th>&nbsp;</th>
                <th><?php echo TITLE; ?></th>
                <th><?php echo DESCRIPTION; ?></th>
                <th><?php echo PLACEMENT; ?></th>
            </tr>
<?php

    $sort_order = 0;

    /* Block display the plugins per placement location. */
    $plugin_placements = array('left', 'right', 'hide');

    foreach ($plugin_placements as $plugin_placement) {
        $plugins = serendipity_plugin_api::enum_plugins($plugin_placement);

        if (!is_array($plugins)) {
            continue;
        }

        $sort_idx = 0;
        foreach ($plugins as $plugin_data) {
            $plugin =& serendipity_plugin_api::load_plugin($plugin_data['name']);
            $key    = urlencode($plugin_data['name']);

            /* query for its name, description and configuration data */
            $bag = new serendipity_property_bag;
            $plugin->introspect($bag);

            $name  = htmlentities($bag->get('name'));
            $desc  = htmlentities($bag->get('description'));
            $place = placement_box('serendipity[placement][' . $plugin_data['name'] . ']', $plugin_data['placement']);

            $title = '';

            ob_start();
            $plugin->generate_content($title);
            ob_end_clean();

            if (strlen(trim($title)) == 0) {
                $title = '&nbsp;';
            }

            if ($bag->is_set('configuration')) {
                $url   = '?serendipity[adminModule]=plugins&serendipity[plugin_to_conf]=' . $key;
                $desc  = '<a href="' . $url . '">' . $desc  . '</a>';
                $name  = '<a href="' . $url . '">' . $name  . '</a>';
                $title = '<a href="' . $url . '">' . $title . '</a>';
            }

            /* Only display UP/DOWN links if there's somewhere for the plugin to go */
            if ($sort_idx == 0) {
                $moveup   = '';
            } else {
                $moveup   = '<a href="?serendipity[adminModule]=plugins&amp;submit=move+up&amp;serendipity[plugin_to_move]=' . $key . '">' . UP . '</a>';
            }

            if ($sort_idx == (count($plugins)-1)) {
                $movedown = '';
            } else {
                $movedown = ($moveup != '' ? '&nbsp;' : '') . '<a href="?serendipity[adminModule]=plugins&amp;submit=move+down&serendipity[plugin_to_move]=' . $key . '">' . DOWN . '</a>';
            }
?>
            <tr>
                <td style="border-bottom: 1px solid #000000">
                    <div>
                        <input type="checkbox" name="serendipity[plugin_to_remove][]" value="<?php echo $plugin_data['name']; ?>">
                    </div>
                </td>

                <td style="border-bottom: 1px solid #000000"><?php echo $title; ?></td>
                <td style="border-bottom: 1px solid #000000"><?php echo $desc; ?></td>
                <td style="border-bottom: 1px solid #000000" nowrap="nowrap">
                    <div><?php echo $place . $moveup . $movedown; ?></div>
                </td>
            </tr>
<?php
            $sort_idx++;
        }
    }
?>
        </table>
        <br />

        <input type="submit" name="REMOVE" title="<?php echo REMOVE_TICKED_PLUGINS; ?>"  value="<?php echo DELETE; ?>" />
        <input type="submit" name="SAVE"   title="<?php echo SAVE_CHANGES_TO_LAYOUT; ?>" value="<?php echo SAVE; ?>"   />
    </div>
</form>
<?php
}
/* vim: set sts=4 ts=4 expandtab : */
?>
