<?php # $Id: serendipity_config.inc.php,v 1.42 2003/12/05 19:13:06 tomsommer Exp $

define('IS_installed', file_exists((isset($serendipity['serendipityPath']) ? $serendipity['serendipityPath'] : '') . 'serendipity_config_local.inc.php'));

if ( IS_installed === true ) {
    define('IN_serendipity', true);
}

include_once('compat.php');
ini_set('session.use_trans_sid', 0);

$serendipity['version']    = '0.4-CVS';
$serendipity['production'] = 1;
$serendipity['rewrite']    = true;

if ( $serendipity['production'] == 1 ) {
    error_reporting(E_ALL & ~E_NOTICE);
} else {
    error_reporting(E_ALL);
}

// Can the user change the date of publishing for an entry?
$serendipity['allowDateManipulation'] = true;

// Is the possibility to comment and entry enabled by default?
$serendipity['allowCommentsDefault'] = true;

/*
 *   Load main language file
 */
include('serendipity_lang.inc.php');

/*
 *   Kill the script if we are not installed, and not inside the installer
 */
if ( !defined('IN_installer') && IS_installed === false ) {
    die(sprintf(SERENDIPITY_NOT_INSTALLED, 'serendipity_admin.php'));
}
if ( defined('IN_installer') && IS_installed === false) {
    return 1;
}

/*
 *   Load DB configuration information
 *   Load Functions
 */
include_once("{$serendipity['serendipityPath']}serendipity_config_local.inc.php");
include_once("{$serendipity['serendipityPath']}serendipity_functions.inc.php");

if (serendipity_FUNCTIONS_LOADED!== true) {
    die(sprintf(INCLUDE_ERROR, 'serendipity_functions.inc.php'));
}

/*
 *   Attempt to connect to the database
 */
if (!serendipity_db_connect()) {
    die(DATABASE_ERROR);
}

$translation = array('true'  => true,
                     'false' => false);

/*
 *   Load Configuration options from the database
 */
$rows = serendipity_db_query("SELECT name,value
                                FROM {$serendipity['dbPrefix']}config");
foreach ($rows as $row) {
    /* fixme: temp. workaround */
    $serendipity['CONFIG'][$row['name']] = $row['value'];

    /*
     *   Convert 'true' and 'false' into booleans
     */
    if ( isset($translation[$row['value']]) ) {
        $row['value'] = $translation[$row['value']];
    }
    $serendipity[$row['name']] = $row['value'];
}

/*
 *   Load main language file again, because now we have the preferred language
 */
include($serendipity['serendipityPath'] .'serendipity_lang.inc.php');

if ($serendipity['embed'] && ($serendipity['embed'] === 'true' || $serendipity['embed'] === true)) {
    $serendipity['baseURL'] = 'http://' . $_SERVER['HTTP_HOST'] . $serendipity['serendipityHTTPPath'];
}

// A Set of emoticons to rewrite
$serendipity['smiles'] = array( ":'("  => $serendipity['baseURL'] . 'pixel/cry_smile.gif',
                                ':-)'  => $serendipity['baseURL'] . 'pixel/regular_smile.gif',
                                ':-O'  => $serendipity['baseURL'] . 'pixel/embaressed_smile.gif',
                                ':O'   => $serendipity['baseURL'] . 'pixel/embaressed_smile.gif',
                                ':-('  => $serendipity['baseURL'] . 'pixel/sad_smile.gif',
                                ':('   => $serendipity['baseURL'] . 'pixel/sad_smile.gif',
                                ':)'   => $serendipity['baseURL'] . 'pixel/regular_smile.gif',
                                '8-)'  => $serendipity['baseURL'] . 'pixel/shades_smile.gif',
                                ':-D'  => $serendipity['baseURL'] . 'pixel/teeth_smile.gif',
                                ':D'   => $serendipity['baseURL'] . 'pixel/teeth_smile.gif',
                                '8)'   => $serendipity['baseURL'] . 'pixel/shades_smile.gif',
                                ':-P'  => $serendipity['baseURL'] . 'pixel/tounge_smile.gif',
                                ';-)'  => $serendipity['baseURL'] . 'pixel/wink_smile.gif',
                                ';)'   => $serendipity['baseURL'] . 'pixel/wink_smile.gif',
                                ':P'   => $serendipity['baseURL'] . 'pixel/tounge_smile.gif',
);

// We don't care who tells us what to do
if (!isset($serendipity['GET']['action'])) {
    $serendipity['GET']['action'] = (isset($serendipity['POST']['action']) ? $serendipity['POST']['action'] : '');
}

if (!isset($serendipity['GET']['adminAction'])) {
    $serendipity['GET']['adminAction'] = (isset($serendipity['POST']['adminAction']) ? $serendipity['POST']['adminAction'] : '');
}

// Some stuff...
if (!isset($_SESSION['serendipityAuthedUser'])) {
    $_SESSION['serendipityAuthedUser'] = false;
}

$serendipity['user']  = isset($_SESSION['serendipityUser'])  ? $_SESSION['serendipityUser']  : '';
$serendipity['email'] = isset($_SESSION['serendipityEmail']) ? $_SESSION['serendipityEmail'] : '';

/* Signature sent with all mails */
$serendipity['signature'] = sprintf(SIGNATURE, $serendipity['blogTitle']);

/* Default mail headers */
$serendipity['mailheaders'] = 'X-Mailer: Serendipity/'. $serendipity['version'] . "\n"
                            . 'X-Engine: PHP/'. phpversion();
/* vim: set sts=4 ts=4 expandtab : */
?>
