<?php # $Id: serendipity_db_mysql.inc.php,v 1.16 2003/11/11 16:22:31 garvinhicking Exp $

/* Issues a query to the underlying database;
 * returns:
 *   false if there was an error,
 *   true if the query succeeded but did not generate any rows
 *   array of field values if it returned a single row and $single is true
 *   array of array of field values if it returned row(s)
 */
function serendipity_db_query($sql, $single = false, $result_type = "both", $reportErr=false)
{
    global $serendipity;
    static $type_map = array(
                         'assoc' => MYSQL_ASSOC,
                         'num'   => MYSQL_NUM,
                         'both'  => MYSQL_BOTH
    );

    // highlight_string(var_export($sql, 1));

    $c = mysql_query($sql);
    if (mysql_error() != '') {
        return mysql_error();
    }

    if (!$c) {
        if (!$serendipity['production']) {
            print mysql_error();
            if (function_exists('debug_backtrace') && $reportErr == true) {
                highlight_string(var_export(debug_backtrace(), 1));
            }
        }

        return false;
    }
    if ($c === true) {
        return true;
    }

    $result_type = $type_map[$result_type];

    switch(mysql_num_rows($c)) {
        case 0:
            if ($single) {
                return false;
            }
            return true;
        case 1:
            if ($single) {
                return mysql_fetch_array($c, $result_type);
            }
        default:
            if ($single) {
                return mysql_fetch_array($c, $result_type);
            }

            $rows = array();
            while (($row = mysql_fetch_array($c, $result_type))) {
                $rows[] = $row;
            }
            return $rows;
    }
}

function serendipity_db_insert_id()
{
    return mysql_insert_id();
}

function serendipity_db_affected_rows()
{
    return mysql_affected_rows();
}

function serendipity_db_escape_string($string)
{
    return mysql_escape_string($string);
}

function serendipity_db_limit($start, $offset)
{
    return $start . ', ' . $offset;
}

function serendipity_db_connect()
{
    global $serendipity;

    if (isset($serendipity['dbConn'])) {
        return $serendipity['dbConn'];
    }

    $serendipity['dbConn'] = mysql_connect($serendipity['dbHost'], $serendipity['dbUser'], $serendipity['dbPass']);
    mysql_select_db($serendipity['dbName']);
    return $serendipity['dbConn'];
}

function serendipity_db_schema_import($query)
{
    static $search  = array('{AUTOINCREMENT}', '{PRIMARY}', 
        '{UNSIGNED}', '{FULLTEXT}', '{BOOLEAN}');
    static $replace = array('int(11) not null auto_increment', 'primary key',
        'unsigned'  , 'FULLTEXT', 'enum (\'true\', \'false\') NOT NULL default \'true\'');

    return serendipity_db_query(str_replace($search, $replace, $query));
}

/* probes the usability of the DB during installation */
function serendipity_db_probe($hash, &$errs)
{
    global $serendipity;

    if (!($c = @mysql_connect($hash['dbHost'], $hash['dbUser'], $hash['dbPass']))) {
        $errs[] = 'Could not connect to database; check your settings.';
        $errs[] = 'The mySQL error was: ' . mysql_error();
        return false;
    }

    $serendipity['dbConn'] = $c;

    if (!@mysql_select_db($hash['dbName'])) {
        $errs[] = 'The database you specified does not exist.';
        $errs[] = 'The mySQL error was: ' . mysql_error();
        return false;
    }

    return true;
}

/* vim: set sts=4 ts=4 expandtab : */
?>
