<?php # $Id: serendipity_functions.inc.php,v 1.168 2003/11/14 12:27:25 garvinhicking Exp $

include_once('./serendipity_db.inc.php');
include_once('./compat.php');
include_once('./serendipity_functions_config.inc.php');
$serendipity['imageList'] = array();

function serendipity_userLoggedIn() {
    global $serendipity;
    if (serendipity_authenticate_author((isset($serendipity['POST']['user']) ? $serendipity['POST']['user'] : ''), (isset($serendipity['POST']['pass']) ? $serendipity['POST']['pass'] : ''))) {
        $_SESSION['serendipityAuthedUser'] = true;
        return true;
    }

    if ($_SESSION['serendipityAuthedUser'] === true && file_exists($serendipity['serendipityPath'] . 'serendipity_config_local.inc.php')) {
        return true;
    } else {
        return false;
    }

}

function serendipity_printLogin() {
?>
    <td class="serendipity_admin">
    <div class='serendipity_auth_required'>
            <?php echo HAVE_TO_BE_LOGGED_ON; ?>
            <form action="?" method="post">
                <input type="hidden"   name="serendipity[action]" value="admin" />
                <input type="text"     name="serendipity[user]"   value="<?php echo USERNAME; ?>" onfocus="value='';" />
                <input type="password" name="serendipity[pass]"   value="<?php echo PASSWORD ?>"  onfocus="value='';" />
                <input type="submit"   name="submit"              value="&gt;" />
           </form>
    </div>
<?php
}

function serendipity_getTemplateFile($file) {
    global $serendipity;
    if ( file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . $serendipity['CONFIG']['template'] . '/'. $file) ) {
        return $serendipity['serendipityHTTPPath'] . $serendipity['templatePath'] . $serendipity['CONFIG']['template'] . '/' . $file;
    }
    if ( file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . 'default/'.  $file) ) {
        return $serendipity['serendipityHTTPPath'] . $serendipity['templatePath'] . 'default/' . $file;
    }
}

function serendipity_fetchTemplates() {
    global $serendipity;
    $dir = opendir($serendipity['serendipityPath'] . $serendipity['templatePath']);
    while ( ($file = readdir($dir)) !== false ) {
        if ( is_dir($serendipity['serendipityPath'] . $serendipity['templatePath'] . $file) && !ereg('^(\.|CVS)', $file) ) {
            $rv[] = $file;
        }
    }
    return $rv;
}

function serendipity_fetchTemplateInfo($theme) {
    global $serendipity;
    /* Blame jannis */
    $lines = file($serendipity['serendipityPath'] . $serendipity['templatePath'] . $theme . '/info.txt');

    for($x=0; $x<count($lines); $x++) {
        $j = preg_split('/([^\:]+)\:/', $lines[$x], -1, PREG_SPLIT_DELIM_CAPTURE);
        if ($j[2]) {
            $currSec = $j[1];
            $data[strtolower($currSec)][] = trim($j[2]);
        } else {
            $data[strtolower($currSec)][] = trim($j[0]);
        }
    }

    foreach ($data as $k => $v) {
        $data[$k] = implode("\n", $v);
    }

    return $data;
}

function serendipity_saveTemplateSelection($theme = 'default') {
    serendipity_set_config_var('template', $theme);
}

function serendipity_printTemplates($themelist) {
    global $serendipity;
?>
<div>
    <form method="post" action="<?php echo $serendipity['serendipityHTTPPath']; ?>serendipity_admin.php?serendipity[adminModule]=templates&amp;serendipity[adminAction]=save">
    <table width="100%" class="prettyTable">
<?php
    foreach ($themelist as $theme) {
        $info = serendipity_fetchTemplateInfo($theme);
        if ( file_exists($serendipity['serendipityPath'] . $serendipity['templatePath'] . $theme . '/preview.png') ) {
            $preview = '<img src="templates/' . $theme . '/preview.png" width="100" style="border: 1px #000000 solid" />';
        } else {
            $preview = '&nbsp;';
        }

        if (serendipity_get_config_var('template', 'default') == $theme) {
            $is_active = 'checked="checked"';
        } else {
            $is_active = '';
        }
?>
        <tr>
            <td colspan="3"><strong><?php echo $info['name']; ?></strong></td>
        </tr>

        <tr>
            <td width="100"><?php echo $preview; ?></td>

            <td valign="top">
                <?php echo AUTHOR; ?>      : <?php echo $info['author'];?><br />
                <?php echo LAST_UPDATED; ?>: <?php echo $info['date'];  ?>
            </td>

            <td valign="middle">
                <div><input type="radio" name="serendipity[theme]" value="<?php echo $theme; ?>" <?php echo $is_active; ?> /></div>
            </td>
        </tr>
<?php
    }
?>
        <tr>
            <td align="right" colspan="3">
                <div><input type="submit" name="submit" value="<?php echo SET_AS_TEMPLATE; ?>" /></div>
            </td>
        </tr>
    </table>
    </form>
</div>
<?php
}

function serendipity_displayCommentForm($id) {
    global $serendipity;

?>
<div class="serendipityCommentForm">
    <form <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="serendipity_comment" action="<?php echo $serendipity['serendipityHTTPPath']; ?>comment.php" method="post" onsubmit="if (this.serendipity_remember.checked) rememberMe(this, '<?php echo $_SERVER['HTTP_HOST']; ?>')">
    <div><input type="hidden" name="serendipity[entry_id]" value="<?php echo $id; ?>" /></div>

    <table border="0" width="100%" cellpadding="3">
        <tr>
            <td class="serendipity_commentsLabel"><?php echo NAME; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[name]" value="<?php echo $serendipity['COOKIE']['name'] ; ?>" size="30" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo EMAIL; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[email]" value="<?php echo $serendipity['COOKIE']['email'] ; ?>" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo HOMEPAGE; ?></td>
            <td class="serendipity_commentsValue"><input type="text" name="serendipity[url]" value="<?php echo $serendipity['COOKIE']['url'] ; ?>" /></td>
        </tr>

        <tr>
            <td class="serendipity_commentsLabel"><?php echo COMMENT; ?></td>
            <td class="serendipity_commentsValue"><textarea rows="10" cols="40" name="serendipity[comment]"></textarea></td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td class="serendipity_commentsLabel">
                <input id="checkbox_remember" type="checkbox" name="serendipity[remember]" <?php echo $serendipity['COOKIE']['remember'] ; ?> /><label for="checkbox_remember"> <?php echo REMEMBER_INFO; ?></label>
<?php
    if ($serendipity['allowSubscriptions']) {
?>
                <br />
                <input id="checkbox_subscribe" type="checkbox" name="serendipity[subscribe]" /><label for="checkbox_subscribe"> <?php echo SUBSCRIBE_TO_THIS_ENTRY; ?></label>
<?php
    }
?>
            </td>
       </tr>
       <tr>
            <td>&nbsp;</td>
            <td><input type="submit" value="<?php echo SUBMIT_COMMENT; ?>" /></td>
        </tr>
    </table>
    </form>
</div>
<?php
}

function serendipity_setCookie($name,$value) {
    global $serendipity;
    setcookie("serendipity[$name]", $value, time()+60*60*24*30, $serendipity['serendipityHTTPPath']);
    $_COOKIE[$name] = $value;
}

function serendipity_deleteCookie($name) {
    setcookie("serendipity[$name]", '', time()-4000);
    unset($_COOKIE[$name]);
}

function serendipity_rememberCommentDetails($details) {
    foreach ( $details as $n=>$v ) {
        serendipity_setCookie($n, $v);
    }
}
function serendipity_forgetCommentDetails() {
    global $serendipity;
    if(!$serendipity['COOKIE']) {
        return;
    }
    foreach ($serendipity['COOKIE'] as $n => $v) {
        serendipity_deleteCookie($n);
    }
}

// Draws a little calendar in HTML
function serendipity_drawCalendar($month, $year) {
    global $serendipity;

    // Catch faulty month
    if ($month<1) {
        $month = 1;
    }
    $month = sprintf('%d', $month);

    // How many days does the month have?
    $ts              = strtotime($year . '-' . sprintf('%02d', $month) . '-01');
    $nrOfDays        = date('t', $ts);
    $firstDayWeekDay = date('w', $ts);

    // Shift the weekday a little, we want monday to be day number 0
    if ($firstDayWeekDay >0) {
        $firstDayWeekDay -=1;
    } else {
        $firstDayWeekDay = 6;
    }

    // Calculate the number of next/previous month
    if ($month > 1) {
        $previousMonth = $month-1;
        $previousYear  = $year;
    } else {
        $previousMonth = 12;
        $previousYear  = $year-1;
    }

    if ($month <12) {
        $nextMonth = $month+1;
        $nextYear  = $year;
    } else {
        $nextMonth = 1;
        $nextYear  = $year+1;
    }

    $endts = mktime(23, 59, 59, $month + 1, 1, $year);

    // Get first and last entry
    $minmax = serendipity_db_query("SELECT MAX(timestamp) AS max, MIN(timestamp) AS min FROM {$serendipity['dbPrefix']}entries");
    if (!is_array($minmax) || !is_array($minmax[0]) || $minmax[0]['min'] < 1 || $minmax[0]['max'] < 1) {
        // If no entry is available yet, allow scrolling a year back and forth
        $minmax = array(
                    '0' => array(
                             'min' => mktime(0, 0, 0, 1, 1, date('Y')-1),
                             'max' => mktime(0, 0, 0, 1, 1, date('Y'+1))
                           )
                  );
    }

    // Find out about diary entries
    $querystring = "SELECT timestamp from {$serendipity['dbPrefix']}entries WHERE timestamp >= $ts and timestamp <= $endts AND isdraft = 'false'";
    $add_query   = '';
    $base_query  = '';
    if (isset($serendipity['GET']['category'])) {
        $_categoryid = explode('_', $serendipity['GET']['category']);
        $categoryid  = serendipity_db_escape_string($_categoryid[0]);

        if (is_numeric($categoryid)) {
            $querystring .= " AND categoryid = $categoryid";
            $base_query   = 'serendipity[category]=' . $categoryid;
            $add_query    = '&amp;' . $base_query;
        }
    }

    $rows = serendipity_db_query($querystring);
    $activeDays = array();
    if (is_array($rows)) {
        foreach ($rows as $row) {
            $activeDays[date('j', $row['timestamp'])] = $row['timestamp'];
        }
    }

    // Prepare the table
    if ($serendipity['rewrite'] == true) {
        $link = $serendipity['serendipityHTTPPath'] . 'archives/' . $year . sprintf('%02d', $month) . '.html?' . $base_query;
    } else {
        $link = 'fixme';
    }
?>
<table width="100%" class="serendipity_calendar" cellspacing="1">
    <tr>
        <td align="left" class="serendipity_calendarHeader">
<?php
    // Only allow to scroll to the previous month if the first entry is from the month before
    if ($ts > ($minmax[0]['min'] - 2678400)) {
?>
            <a title="<?php echo BACK; ?>" href="<?php echo $serendipity['serendipityHTTPPath'] . $serendipity['indexFile']; ?>?serendipity[calendarZoom]=<?php echo $previousYear . sprintf('%02d',$previousMonth) . $add_query; ?>"><img alt="<?php echo BACK; ?>" src="<?php echo serendipity_getTemplateFile('img/back.png'); ?>" border="0" /></a>
<?php
    }
?>
        </td>

        <td colspan="5" align="center" valign="bottom" class="serendipity_calendarHeader">
            <b><?php echo ($serendipity['XHTML11'] ? '<span style="white-space: nowrap">' : '<nobr>'); ?><a href="<?php echo $link; ?>"><?php echo $serendipity["months"][$month] . ' \'' . substr($year, 2); ?></a><?php echo ($serendipity['XHTML11'] ? '</span>' : '</nobr>'); ?></b>
        </td>

        <td align="right" class="serendipity_calendarHeader">
<?php
    // Only allow to scroll to the next month if the last entry is from the month before
    if ($endts < ($minmax[0]['max'] + 2678400)) {
?>
            <a title="<?php echo FORWARD; ?>" href="<?php echo $serendipity['serendipityHTTPPath'] . $serendipity['indexFile']; ?>?serendipity[calendarZoom]=<?php echo $nextYear . sprintf('%02d', $nextMonth) . $add_query; ?>"><img alt="<?php echo FORWARD; ?>" src="<?php echo serendipity_getTemplateFile('img/forward.png'); ?>" border="0" /></a>
<?php
    }
?>
        </td>
    </tr>

    <tr>
<?php
foreach($serendipity['weekDayAbb'] AS $weekKey => $weekVal) {
?>
        <td class="serendipity_weekDayName" align="center"><?php echo $weekVal; ?></td>
<?php
}
?>
    </tr>

<?php
    // Print the calendar
    $currDay = 1;
    for ($x=0; $x<6; $x++) {
        // Break out if we are out of days
        if ($currDay>$nrOfDays) {
            break;
        }
?>
    <tr class="serendipity_calendar">
<?php
        // Prepare row
        for ($y=0; $y<7; $y++) {
            // Be able to print borders nicely
            if ($x == 4 && $y == 6) {
                $cellProp = 'LastInLastRow';
            } else if ($y == 0) {
                $cellProp = 'FirstInRow';
            } else if ($y == 6) {
                $cellProp = 'LastInRow';
            } else if ($x == 4) {
                $cellProp = 'LastRow';
            } else {
                $cellProp = '';
            }

            // Start printing
            if ( ($x > 0 || $y >= $firstDayWeekDay)
                 && $currDay <= $nrOfDays) {

                if (isset($activeDays[$currDay]) && $activeDays[$currDay] > 1) {
                    $cellProp .= 'Active';
                }

                // Print day
                if ($serendipity['rewrite'] == true) {
                    $link = $serendipity['serendipityHTTPPath'] . 'archives/' . date('Ymd', mktime(0,0,0, $month, $currDay, $year)) . '.html?' . $base_query;
                } else {
                    $link = 'fixme!';
                }

                if (date('m')    == $month
                    && date('Y') == $year
                    && $currDay  == date('j')) {
                    $att_start = '<i>';
                    $att_end   = '</i>';
                } else {
                    $att_start = '';
                    $att_end   = '';
                }

                if (isset($activeDays[$currDay]) && $activeDays[$currDay] > 1) {
                    $lnk_start = '<a href="' . $link . '">'; //?month=".sprintf("%02d",$month)."&year=$year'>");
                    $lnk_end   = '</a>';
                } else {
                    $lnk_start = '';
                    $lnk_end   = '';
                }

                $currDay++;
?>
        <td class="serendipity_calendarDay<?php echo $cellProp; ?>">
            <?php echo $att_start . $lnk_start . ($currDay - 1) . $lnk_end . $att_end; ?>
        </td>
<?php
            } else {
?>
        <td class="serendipity_calendarBlankDay<?php echo $cellProp; ?>">&nbsp;</td>
<?php
            } // end if (print day)
        } // end for-loop (inner: days)
?>
    </tr>
<?php
    } // end for-loop (outer: weeks)
?>
</table>
<?php
} // end function: serendipity_drawCalendar

/**
* Give it a range in YYYYMMDD format to gather the desired entries
* (For february 2002 you would pass 200202 e.g.
**/
function serendipity_fetchEntries($range = null, $full = true, $limit = '', $fetchDrafts = 'false') {
    global $serendipity;

    if ($full === true) {
        $body = ',body, extended';
    }

    if ($fetchDrafts == 'false') {
        $drafts = "isdraft = 'false'";
    }

    if (is_numeric($range)) {
        $year = (int)substr($range, 0, 4);
        $month = (int)substr($range, 4, 2);
        $day = (int)substr($range, 6, 2);

        $startts = mktime(0, 0, 0, $month, ($day == 0 ? 1 : $day), $year);

        if ($day == 0) {
            $month++;
        } else {
            $day++;
        }

        $endts = mktime(0, 0, 0, $month, ($day == 0 ? 1 : $day), $year);

        $and = " WHERE timestamp >= $startts AND timestamp <= $endts";
        if ($drafts) {
            $and .= " AND $drafts";
        }
    } else {
        $and = '';
        if ($drafts) {
            $and .= "WHERE $drafts";
        }
    }

    if (isset($serendipity['GET']['category'])) {
        $_categoryid = explode('_', $serendipity['GET']['category']);
        $categoryid  = serendipity_db_escape_string($_categoryid[0]);

        if (is_numeric($categoryid)) {
            if ($and != '') {
                $and .= " AND e.categoryid = $categoryid";
            } else {
                $and = "WHERE e.categoryid = $categoryid";
            }
        }
    }

    if (!empty($limit)) {
        if (isset($serendipity['GET']['page']) && $serendipity['GET']['page'] > 1 && !strstr($limit, ',')) {
            $limit = (($serendipity['GET']['page']-1)*$limit) . ',' . $limit;
        }

        if (strtolower($serendipity['dbType']) == 'postgres') {
            $limit = 'LIMIT ' . join (' OFFSET ', split(',', $limit));
        } else {
            $limit = 'LIMIT '. $limit;
        }
    }

    $query = "SELECT
                    e.*,
                    a.username,
                    a.email,
                    c.category_name,
                    c.categoryid
              FROM
                    ({$serendipity['dbPrefix']}entries AS e
                        LEFT JOIN {$serendipity['dbPrefix']}category c
                        ON e.categoryid = c.categoryid)
                    LEFT JOIN {$serendipity['dbPrefix']}authors a
                        ON e.authorid = a.authorid $and
                    ORDER BY
                        timestamp DESC
                    $limit";

    $ret = serendipity_db_query($query);
    if (is_string($ret)) {
        die("Query failed: $ret");
    }

    return $ret;
}

/**
* Fetches a specific entry
**/
function serendipity_fetchEntry($key, $val, $full = true) {
    global $serendipity;

    if ($full === true) {
        $body = ', body, extended';
    }
    $querystring = "SELECT
                            *,
                            c.category_name,
                            c.categoryid,
                            a.username,
                            a.email
                    FROM
                            {$serendipity['dbPrefix']}entries e
                                LEFT JOIN {$serendipity['dbPrefix']}category c
                                ON e.categoryid = c.categoryid,
                            {$serendipity['dbPrefix']}authors a
                    WHERE
                            a.authorid = e.authorid
                            AND $key LIKE $val
                    LIMIT 1";

    return serendipity_db_query($querystring, true);
}

/**
* Fetches a users categories
**/
function serendipity_fetchCategories($authorid = null) {
    global $serendipity;

    if (!isset($authorid) || $authorid === null) {
        $authorid = (isset($serendipity['authorid']) ? $serendipity['authorid'] : 1);
    }

    if ($authorid != 'all') {
        $where = "WHERE authorid = $authorid";
    } else {
        $where = '';
    }

    $querystring = "SELECT * FROM {$serendipity['dbPrefix']}category $where ORDER BY category_name";

    return serendipity_db_query($querystring);
}


/**
* Give it a raw searchstring, it'll search
**/
function serendipity_searchEntries($term) {
    global $serendipity;

    $querystring = "SELECT
                            e.id,
                            e.author,
                            a.username,
                            a.email,
                            e.categoryid,
                            c.category_name,
                            e.timestamp,
                            e.comments,
                            e.title,
                            e.body,
                            e.extended,
                            e.trackbacks,
                            e.exflag
                    FROM
                            {$serendipity['dbPrefix']}entries e
                                LEFT JOIN {$serendipity['dbPrefix']}category c
                                ON e.categoryid = c.categoryid,
                            {$serendipity['dbPrefix']}authors a
                    WHERE
                            a.authorid = e.authorid
                            AND MATCH (title,body,extended) AGAINST ('".addslashes($term)."')
                    ORDER BY
                            timestamp DESC";

    return serendipity_db_query($querystring);
}

/**
*  Creates a filename that consists of [a-zA-z0-9_] (with some custom adjustments (space -> _,  -> ae and such)
**/
function serendipity_makeFilename($str) {
    $str = str_replace('', 'AE', $str);
    $str = str_replace('', 'ae', $str);
    $str = str_replace('', 'OE', $str);
    $str = str_replace('', 'oe', $str);
    $str = str_replace('', 'UE', $str);
    $str = str_replace('', 'ue', $str);
    $str = str_replace('', 'sz', $str);
    $str = str_replace(' ', '_' , $str);
    return preg_replace('#[^\w]#', '', $str);
}

/** Print a footer below the list of entries
 *
 **/
function serendipity_printEntryFooter() {
global $serendipity;

    // build the query string with variables we want to carry from each page to page
    $add_query = '';
    if (is_array($serendipity['GET'])) {
        $page_get_array = $serendipity['GET'];
        unset($page_get_array['page']);
        unset($page_get_array['range']);
        unset($page_get_array['action']);
        unset($page_get_array['adminAction']);

        foreach($page_get_array AS $skey => $sval) {
            $add_query .= '&amp;serendipity[' . urlencode($skey) . ']=' . urlencode($sval);
        }
    }

    $querystring  = "SELECT count(id) FROM {$serendipity['dbPrefix']}entries WHERE isdraft = 'false'";
    if (isset($serendipity['GET']['category'])) {
        $_categoryid = explode('_', $serendipity['GET']['category']);
        $categoryid  = serendipity_db_escape_string($_categoryid[0]);

        if (is_numeric($categoryid)) {
            $querystring .= " AND categoryid = $categoryid";
        }
    }

    $query        = serendipity_db_query($querystring);
    $totalEntries = $query[0][0];
    $totalPages   = ceil($totalEntries / 15);

    if (!isset($serendipity['GET']['page'])) {
        $serendipity['GET']['page'] = 1;
    }
?>
<div class='serendipity_entryFooter' style="text-align: center">
<?php
    if ($serendipity['GET']['page'] > 1) {
?>
<a href="<?php echo $serendipity['baseURL'] . $serendipity['indexFile'] . '?serendipity[page]=' . ($serendipity['GET']['page'] - 1) . $add_query; ?>">&laquo; <?php echo PREVIOUS_PAGE; ?></a>&nbsp;&nbsp;
<?php
    }
?>
(<?php printf(PAGE_BROWSE, $serendipity['GET']['page'], $totalPages, $totalEntries); ?>)
<?php
    if ($serendipity['GET']['page'] < $totalPages) {
?>
&nbsp;&nbsp;<a href="<?php echo $serendipity['baseURL'] . $serendipity['indexFile'] . '?serendipity[page]=' . ($serendipity['GET']['page'] + 1) . $add_query; ?>"><?php echo NEXT_PAGE; ?> &raquo;</a>
<?php
    }
?>
</div>
<?php
}

/**
* Prints the entries you fetched with serendipity_fetchEntries/searchEntries in HTML.
**/
function serendipity_printEntries($entries, $extended = 0) {
    global $serendipity;

    /* pre-walk the array to collect them keyed by date */
    $bydate = array();
    if (!is_array($entries) || $entries[0] == false) {
        echo '<br />' . NO_ENTRIES_TO_PRINT . "\n";
        return;
    }

    $lastDate = '';
    for ($x = 0, $num_entries = count($entries); $x < $num_entries; $x++) {
        $d = date(DATE_FORMAT_1, $entries[$x]['timestamp']);
        $bydate[$d][] = $entries[$x];
    }

    if (!isset($serendipity['GET']['short']) || !$serendipity['GET']['short']) {
        foreach ($bydate as $date => $ents) {
?>

    <div class="serendipity_Entry_Date">
        <h3 class="serendipity_date"><?php echo $date; ?></h3>

<?php
            foreach ($ents as $x => $entry) {
                $entryLink = serendipity_archiveURL($entry['id'], $entry['title'], 'serendipityHTTPPath');

                $html_extended = '';
                if ($extended && strlen($entry['extended'])) {
                    $html_extended = '<a ' . ($serendipity['XHTML11'] ? 'id' : 'name') . '="#extended"></a>';
                    $html_extended .= nl2br(serendipity_emoticate(serendipity_markup_text($entry['extended'], $entry['id'])));
                }

                if ($entry['exflag'] && !$extended) {
                    $html_extended = '<br /><a href="' . $entryLink . '#extended">' . VIEW_EXTENDED_ENTRY . '</a><br />';
                }

?>
        <h4 class="serendipity_title"><a href="<?php echo $entryLink; ?>"><?php echo htmlentities($entry['title']); ?></a></h4>

        <div class="serendipity_entry">
            <?php echo nl2br(serendipity_emoticate(serendipity_markup_text($entry['body'], $entry['id']))) . $html_extended; ?>

            <div class='serendipity_entryFooter'>
<?php
                echo '                ' . POSTED_BY . ' ' . htmlentities($entry['username']) . ($entry['category_name'] ? ' ' . IN . ' <a href="' . $serendipity['serendipityHTTPPath'] . 'categories/' . $entry['categoryid'] . '_' . serendipity_makeFilename($entry['category_name']) . '">' . $entry['category_name'] . '</a> ' : ' ') . AT . ' <a href="' . $entryLink . '">' . date('H:i', $entry['timestamp']) . '</a>'. "\n";

                if ($entry['allow_comments'] === true || $entry['allow_comments'] == 'true' || !isset($entry['allow_comments']) || $entry['comments'] > 0) {
                    if (!isset($serendipity['GET']['id'])) {
                        $label = $entry['comments'] == 1 ? COMMENT : COMMENTS;
                        echo ' | <a href="' . $serendipity['serendipityHTTPPath'] . 'comment.php?serendipity[entry_id]=' . $entry['id'] . '&amp;serendipity[type]=comments"';
                        echo '      onclick="window.open(this.href, \'comments\', \'width=480,height=480,scrollbars=yes\'); return false;">';
                        echo $label . '(' . $entry['comments'] . ')</a>';
                    }
                }

                if ($entry['allow_comments'] === true || $entry['allow_comments'] == 'true' || !isset($entry['allow_comments']) || $entry['trackbacks'] > 0) {
                    $label = $entry['trackbacks'] == 1 ? TRACKBACK : TRACKBACKS;
                    echo ' | <a href="' . $serendipity['serendipityHTTPPath'] . 'comment.php?serendipity[entry_id]=' . $entry['id'] . '&amp;serendipity[type]=trackbacks"';
                    echo '      onclick="window.open(this.href, \'comments\', \'width=480,height=480,scrollbars=yes\'); return false;">';
                    echo $label . ' (' . $entry['trackbacks'] . ')</a>';
                }
?>
                </div>

                <!--
                <rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
                         xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
                         xmlns:dc="http://purl.org/dc/elements/1.1/">
                <rdf:Description
                         rdf:about="<?php echo $serendipity['baseURL']; ?>feeds/ei_<?php echo $entry['id']; ?>.rdf"
                         trackback:ping="<?php echo $serendipity['baseURL']; ?>comment.php?type=trackback&entry_id=<?php echo $entry['id']; ?>"
                         dc:title="<?php echo $entry['title']; ?>"
                         dc:identifier="<?php echo serendipity_archiveURL($entry['id'], $entry['title']); ?>" />
                </rdf:RDF>
                -->

<?php
                if (isset($serendipity['GET']['id'])) {
?>
            <link rel="pingback" href="<?php echo $serendipity['baseURL']; ?>comment.php?type=pingback&amp;entry_id=<?php echo$entry['id']; ?>" />
            <br />

            <div class="serendipity_commentsTitle"><?php echo COMMENTS; ?></div>
<?php
                    if (preg_match('@/unsubscribe/(.*)/([0-9]+)@', $_SERVER['REQUEST_URI'], $res)) {
                        echo '<div align="center" style="color: #FF0000; font-weight: bold;">'. sprintf(UNSUBSCRIBE_OK, urldecode($res[1])) .'</div><br />';
                    }


                    echo serendipity_printComments(serendipity_fetchComments($entry['id']), (isset($entry['allow_comments']) ? $entry['allow_comments'] : true));
                    if ($entry['allow_comments'] === true || $entry['allow_comments'] == 'true' || !isset($entry['allow_comments'])) {
?>
            <br />
            <div class="serendipity_commentsTitle"><?php echo ADD_COMMENT; ?></div>
                <?php echo serendipity_displayCommentForm($entry['id']); ?>
<?php
                    } else {
?>
            <br />
            <div style="color: #FF0000" align="center"><?php echo COMMENTS_CLOSED; ?></div>
<?php
                    }
                }
?>
        </div>
<?php
            } // end for-loop (entries)
?>
    </div>
<?php
        } // end for-loop (dates)

        if (!isset($serendipity['GET']['id']) &&
               (!isset($serendipity['GET']['hidefooter']) || $serendipity['GET']['hidefooter'] == false) &&
               count($entries) <= 15) {
            serendipity_printEntryFooter();
        }
    } else { // else short mode
        $s = &$serendipity['GET']['range'];
?>
    <div class='serendipity_date'><?php echo TOPICS_OF . date('m/Y', mktime(0, 0, 0, substr($s, 4, 2), 1, substr($s, 0, 4))); ?></div>
<?php
        foreach ($bydate as $date => $ents) {
            foreach ($ents as $x => $entry) {
                echo '<a href="' . serendipity_archiveURL($entry['id'], $entry['title'], 'serendipityHTTPPath') . '">' . $entry['title'] . '</a>' . "\n";
                echo '<br />' . "\n";
            }
        }
    } // end else short mode
} // end function serendipity_printEntries

function serendipity_deleteComment($id, $entry_id, $type='comments')
{
    global $serendipity;

    if ($_SESSION['serendipityAuthedUser'] === true ) {
        $query = "DELETE FROM {$serendipity['dbPrefix']}comments WHERE entry_id = $entry_id AND id = $id";
        serendipity_db_query($query);

        $query = "UPDATE {$serendipity['dbPrefix']}entries SET $type = $type-1 WHERE id = $entry_id";
        serendipity_db_query($query);
        header('Location: '. $_SERVER['HTTP_REFERER']);
    } else {
        die('What are you up to? You need to be an admin to delete comments');
    }
}

function serendipity_allowCommentsToggle($entry_id, $switch = 'disable') {
    global $serendipity;

    if ($_SESSION['serendipityAuthedUser'] === true ) {
        $query = "UPDATE {$serendipity['dbPrefix']}entries SET allow_comments = '" . ($switch == 'disable' ? 'false' : 'true') . "' WHERE id = $entry_id";
        serendipity_db_query($query);
        header('Location: '. $_SERVER['HTTP_REFERER']);
    } else {
        die('What are you up to? You need to be an admin to close comments');
    }
}

function serendipity_fetchComments($id, $limit = null, $order = '')
{
    global $serendipity;

    if (!empty($limit)) {
        if ( strtolower($serendipity['dbType']) == 'postgres' ) {
            $limit = 'LIMIT ' . join (' OFFSET ', split(',', $limit));
        } else {
            $limit = 'LIMIT '. $limit;
        }
    } else {
        $limit = '';
    }

    if (!empty($id)) {
        $and = 'AND co.entry_id=' . $id;
    }

    $query = "SELECT
                    co.*,
                    co.author AS username,
                    e.title,
                    e.id AS entryid,
                    c.category_name
              FROM
                    {$serendipity['dbPrefix']}comments co
                    LEFT JOIN {$serendipity['dbPrefix']}entries e ON (co.entry_id = e.id)
                    LEFT JOIN {$serendipity['dbPrefix']}category c ON (e.categoryid = c.categoryid)
                    WHERE co.type LIKE 'NORMAL' $and
                    ORDER BY
                        co.id " . ($order != '' ? $order : '') . "
                    $limit";

    $comments = serendipity_db_query($query);

    if (!is_array($comments)) {
        return array();
    }

    return $comments;
}

function serendipity_fetchTrackbacks($id, $limit = null)
{
    global $serendipity;

    $query = "SELECT * FROM {$serendipity['dbPrefix']}comments WHERE entry_id=$id AND type = 'TRACKBACK' ORDER BY id";
    if (isset($limit)) {
        $query .= " LIMIT $limit";
    }

    $comments = serendipity_db_query($query);
    if (!is_array($comments)) {
        return array();
    }

    return $comments;
}

function serendipity_printComments($comments, $allow_comments = true)
{
    global $serendipity;
?>

<?php
    if (!count($comments)) {
?>
            <div align="center"><?php echo NO_COMMENTS; ?></div>
<?php
    }

    $x = 0;
    foreach ($comments as $comment) {
        $x++;
        /* Protect submitted mails against spam, by replacing @ with [at]*/
        if ( !empty($comment['email']) ) {
            $comment['email'] = str_replace('@', '[at]', $comment['email']);
        }

        $name = empty($comment['author']) ? ANONYMOUS : $comment['author'];
        $body = htmlentities($comment['body']);
?>
    <div class="serendipity_comment">
            <a <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="c<?php echo $comment['id']; ?>"></a>
            <?php echo nl2br(serendipity_markup_text(serendipity_emoticate($body))); ?><br />

            <div class="serendipity_comment_source">
                <a href="#c<?php echo $comment['id']; ?>" title="<?php echo LINK_TO_COMMENT . $x; ?>">#<?php echo $x ; ?></a> - <?php echo $type . ' '; ?>
<?php
        /* Link to the user's email */
        if ( !empty($comment['email']) ) {
            echo  '<a href="mailto:' . htmlentities($comment['email']) . '"  title="' . SEND_MAIL_TO . ' ' . htmlentities($name) . ' (' . $comment['email'] . ')">' . htmlentities($name) . '</a>';
        } else {
            echo htmlentities($name);
        }

        /* Link to the user's website, if the URL is valid */
        if ( $comment['type'] != 'trackback' && !empty($comment['url']) && $comment['url'] != 'http://' && eregi('^http://', $comment['url']) ) {
            echo ' (<a href="' . str_replace('"', '&quot;', $comment['url']) . '" ' . serendipity_xhtml_target('_blank') . ' title="' . htmlentities($comment['url']) . '">Link</a>)';
        }

        /* Show when the entry was made */
        echo ' ' . ON . ' ' . date('M d, H:i', $comment['timestamp']);

        if ($_SESSION['serendipityAuthedUser'] === true) {
            echo ' (<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[delete]=' . $comment['id'] . '&amp;serendipity[entry]=' . $comment['entry_id'] . '&amp;serendipity[type]=comments">' . DELETE . '</a>)';
        }
?>

            </div>
        </div>
        <br />
<?php
    }

    if ($_SESSION['serendipityAuthedUser'] === true) {
        if ($allow_comments === true || $allow_comments == 'true') {
            echo '<div class="serendipity_comment_source">(<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[switch]=disable&amp;serendipity[entry]=' . $comment['entry_id'] . '">' . COMMENTS_DISABLE . '</a>)</div>';
        } else {
            echo '<div class="serendipity_comment_source">(<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[switch]=enable&amp;serendipity[entry]=' . $comment['entry_id'] . '">' . COMMENTS_ENABLE . '</a>)</div>';
        }
        echo '<br />';
    }
}

function serendipity_printTrackbacks($comments)
{
    global $serendipity;
?>

<table width="100%" border="0">
<?php
    if (!count($comments)) {
?>
    <tr>
        <td>
            <i><?php echo NO_TRACKBACKS; ?></i>
        </td>
    </tr>
<?php
    }

    foreach ($comments as $comment) {
        $link = empty($comment['url']) ? $comment['email'] : $comment['url'];
        $name = empty($comment['author']) ? 'Anonymous' : $comment['author'];
        $title= strip_tags($comment['title']);
?>
    <tr>
        <td class="serendipity_comment">
            <a href="<?php echo strip_tags($link); ?>" <?php echo serendipity_xhtml_target('_blank'); ?>><?php echo $title; ?></a><br />
            <b><?php echo EXCERPT; ?>: </b>
            <?php echo htmlentities(strip_tags($comment['body'])); ?><br />
            <div class="serendipity_comment_source">
                <b>Weblog: </b> <?php echo strip_tags($name); ?><br />
                <b><?php echo TRACKED; ?>: </b> <?php echo date('M d, h:i', $comment['timestamp']); ?>
<?php
        if ($_SESSION["serendipityAuthedUser"] === true) {
            echo '                (<a href="' . $serendipity['baseURL'] . 'comment.php?serendipity[delete]=' . $comment['id'] . '&amp;serendipity[entry]=' . $comment['entry_id'] . '&amp;serendipity[type]=trackbacks">' . DELETE . '</a>)';
        }
?>
            </div>
        </td>
    </tr>
<?php
    }
?>
</table>
<?php
}

function serendipity_saveComment($id, $commentInfo, $type = 'NORMAL') {
    global $serendipity;

    $query = "SELECT allow_comments FROM {$serendipity['dbPrefix']}entries WHERE id = '$id'";
    $ca    = serendipity_db_query($query, true);

    if ($ca['allow_comments'] === true || $ca['allow_comments'] == 'true' || !is_array($ca)) {
        $title         = serendipity_db_escape_string($commentInfo['title']);
        $comments      = $commentInfo['comment'];
        $commentsFixed = serendipity_db_escape_string($commentInfo['comment']);
        $name          = serendipity_db_escape_string($commentInfo['name']);
        $url           = serendipity_db_escape_string($commentInfo['url']);
        $email         = serendipity_db_escape_string($commentInfo['email']);

        if (isset($commentInfo['subscribe'])) {
            $subscribe = 'true';
        } else {
            $subscribe = 'false';
        }

        $t      = time();
        $query  = "INSERT INTO {$serendipity['dbPrefix']}comments (entry_id, author, email, url, body, type, timestamp, title, subscribed)";
        $query .= " VALUES ('$id', '$name', '$email', '$url', '$commentsFixed', '$type', '$t', '$title', '$subscribe')";

        serendipity_db_query($query);

        $field = ($type == 'NORMAL' ? 'comments' : 'trackbacks');
        $query = "UPDATE {$serendipity['dbPrefix']}entries SET $field=$field+1 WHERE id='$id'";
        serendipity_db_query($query);

        $query = "SELECT email, title, mail_comments
                  FROM {$serendipity['dbPrefix']}entries e, {$serendipity['dbPrefix']}authors a
                  WHERE e.id  = '$id'
                  AND e.authorid = a.authorid";
        $row = serendipity_db_query($query, true);

        if ($row['mail_comments']) {
            serendipity_sendComment($row['email'], $name, $email, $url, $id, $row['title'], $comments, $type);
        }

        if ($serendipity['allowSubscriptions']) {
            serendipity_mailSubscribers($id, $name, $email, $row['title'], $row['email']);
        }

        serendipity_purgeEntry($id, $t);
        return true;
    } else {
        return false;
    }
}

function serendipity_mailSubscribers($entry_id, $poster, $posterMail, $title, $fromEmail = 'none@example.com') {
    global $serendipity;

    $entryURI = serendipity_archiveURL($entry_id, $title);
    $subject =  '[' . $serendipity['blogTitle'] . '] ' . sprintf(NEW_COMMENT_TO_SUBSCRIBED_ENTRY, $title);

    if (strtolower($serendipity['dbType']) == 'postgres') {
        $pgsql_insert = "DISTINCT ON (email)";
    } else {
        $mysql_insert = "GROUP BY email";
    }

    $sql = "SELECT $pgsql_insert author, email, type
            FROM {$serendipity['dbPrefix']}comments
            WHERE entry_id = $entry_id
              AND email <> '$posterMail'
              AND subscribed = 'true' $mysql_insert";
    $subscribers = serendipity_db_query($sql);

    if (!is_array($subscribers)) {
        return;
    }

    foreach ($subscribers as $subscriber) {
        if ($subscriber['type'] == 'TRACKBACK') {
            $text = sprintf(
                      SUBSCRIPTION_TRACKBACK_MAIL,

                      $subscriber['author'],
                      $serendipity['blogTitle'],
                      $title,
                      $poster,
                      $entryURI,
                      $serendipity['baseURL'] .'unsubscribe/'. urlencode($subscriber['email']) .'/'. $entry_id
            );
        } else {
            $text = sprintf(
                      SUBSCRIPTION_MAIL,

                      $subscriber['author'],
                      $serendipity['blogTitle'],
                      $title,
                      $poster,
                      $entryURI,
                      $serendipity['baseURL'] .'unsubscribe/'. urlencode($subscriber['email']) .'/'. $entry_id
            );
        }

        mail($subscriber['email'], $subject,  $text . $serendipity['signature'], "From: {$serendipity['blogTitle']} <$fromEmail>\r\n". $serendipity['mailheaders']);
    }
}

function serendipity_cancelSubscription($email, $entry_id) {
    global $serendipity;
    $sql = "UPDATE {$serendipity['dbPrefix']}comments
                SET subscribed = 'false'
            WHERE entry_id = $entry_id
                AND email = '$email'";
    serendipity_db_query($sql);

    return serendipity_db_affected_rows();
}

function serendipity_sendComment($to, $fromName, $fromEmail, $fromUrl, $id, $title, $comment, $type = 'NORMAL') {
    global $serendipity;

    $entryURI = serendipity_archiveURL($id, $title);

    if ($type == 'TRACKBACK') {
        $subject =  '[' . $serendipity['blogTitle'] . '] ' . NEW_TRACKBACK_TO . ' ' . $title;
        $text = sprintf(A_NEW_TRACKBACK_BLAHBLAH, $title)
              . "\n"
              . "\n" . LINK_TO_ENTRY . ': ' . $entryURI
              . "\n" . 'Weblog ' . NAME . ': ' . stripslashes($fromName)
              . "\n" . LINK_TO_REMOTE_ENTRY . ': ' . $fromUrl
              . "\n"
              . "\n" . EXCERPT . ':'
              . "\n" . strip_tags($comment);
    } else {
        $subject = '[' . $serendipity['blogTitle'] . '] ' . NEW_COMMENT_TO . ' ' . $title;
        $text = sprintf(A_NEW_COMMENT_BLAHBLAH, $serendipity[blogTitle], $title)
              . "\n" . LINK_TO_ENTRY . ': ' . $entryURI
              . "\n"
              . "\n" . USER . ' ' . IP_ADDRESS . ': ' . $_SERVER['REMOTE_ADDR']
              . "\n" . USER . ' ' . NAME       . ': ' . $fromName
              . "\n" . USER . ' ' . EMAIL      . ': ' . $fromEmail
              . "\n" . USER . ' website: '            . $fromUrl
              . "\n"
              . "\n" . COMMENTS                . ': '
              . "\n" . strip_tags($comment);
    }

    return mail($to, $subject,  $text . $serendipity['signature'], "From: {$serendipity['blogTitle']} <$fromEmail>\r\n". $serendipity['mailheaders']);
}

function serendipity_fetchReferences($id)
{
    global $serendipity;

    $query = "SELECT name,link FROM {$serendipity['dbPrefix']}references WHERE entry_id='" . serendipity_db_escape_string($id) . "'";

    return serendipity_db_query($query);
}


function serendipity_printEntries_rss($entries, $version, $comments = false) {
    global $serendipity;

    if ($version == '0.91' || $version == '2.0' && is_array($entries)) {
        foreach ($entries as $entry) {
            $guid = serendipity_archiveURL((isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']), $entry['title']);
            if ($comments == true) {
                // Display username as part of the title for easier feed-readability
                $entry['title'] = $entry['username'] . ': ' . $entry['title'];
            }

            // Embed a link to extended entry, if existing
            if ($entry['exflag']) {
                $ext = '<br /><a href="' . $guid . '#extended" title="' . VIEW_EXTENDED_ENTRY . '">' . VIEW_EXTENDED_ENTRY . '</a>';
            } else {
                $ext = '';
            }

            // Do some relative -> absolute URI replacing magic. Replaces all HREF/SRC (<a>, <img>, ...) references to only the serendipitypath with the full baseURL URI
            // garvin: Could impose some problems. Closely watch this one.
            $entry['body'] = preg_replace('@(href|src)=("|\')(' . preg_quote($serendipity['serendipityHTTPPath']) . ')(.*)("|\')(.*)>@imsU', '\1=\2' . $serendipity['baseURL'] . '\4\2\6>', $entry['body']);
?>
<item>
    <title><?php echo utf8_encode(htmlspecialchars($entry['title'])); ?></title>
    <link><?php echo $guid; ?></link>
<?php
            if ($version == '2.0') {
                // extract author information
                if (empty($entry['email'])) {
                    $query = "select email from {$serendipity['dbPrefix']}authors where username='{$entry['username']}'";
                    $results = serendipity_db_query($query);
                    $entry['email'] = $results[0]['email'];
                }
?>
    <category><?php echo utf8_encode(htmlspecialchars($entry['category_name'])); ?></category>
    <comments><?php echo $guid; ?></comments>
<?php
    if ($comments === false) {
?>
    <slash:comments><?php echo $entry['comments']; ?></slash:comments>
    <wfw:commentRss><?php echo $serendipity['baseURL']; ?>rss.php?version=<?php echo $version; ?>&amp;type=comments&amp;cid=<?php echo (isset($entry['entryid']) && $entry['entryid'] != '' ? $entry['entryid'] : $entry['id']); ?></wfw:commentRss>
<?php
    }
?>
    <author><?php echo utf8_encode(htmlspecialchars($entry['email'])) . ' (' . utf8_encode(htmlspecialchars($entry['username'])) . ')'; ?></author>
    <content:encoded>
        <?php echo utf8_encode(htmlspecialchars(nl2br(serendipity_emoticate(serendipity_markup_text($entry['body'] . $ext))))); ?>
    </content:encoded>
    <pubDate><?php echo date('r', $entry['timestamp']); ?></pubDate>
    <guid><?php echo $guid; ?></guid>
<?php
            } else {
?>
    <description>
        <?php echo utf8_encode(htmlspecialchars(nl2br($entry['body'] . $ext))); ?>
    </description>
<?php
            }
?>
</item>
<?php
        }
    } else if ($version == '1.0') {
    }
}

/**
 * Taken from pres2, written by rasmus lerdorf and company
 */
function serendipity_format_tt($arg) {
    return('<tt>' . str_replace(' ', '&nbsp;', $arg[1]) . '</tt>');
}

function serendipity_content_rewrite($str) {
    global $serendipity;

    // Do this only once!
    if (!class_exists('serendipity_plugin_api')) {
        include_once('serendipity_plugin_api.php');
    }

    // If this variable is not set, this function is called for the first time.
    // Now let's search for plugins needing content rewriting
    if (!isset($serendipity['content_rewrite']['active'])) {

        // We set this to false, so when this function is called later, it won't have to enumerate all plugins again
        $serendipity['content_rewrite']['active'] = false;

        // Get those nifty plugins
        $plugins = serendipity_plugin_api::enum_plugins();

        if (is_array($plugins)) {

            // store the rewrite items in our main container for later usage.
            $serendipity['content_rewrite']['data']['rewrite_from'] = array();
            $serendipity['content_rewrite']['data']['rewrite_to']   = array();

            // load each plugin to make some introspection
            foreach ($plugins as $plugin_data) {
                $plugin =& serendipity_plugin_api::load_plugin($plugin_data['name']);
                $bag    = new serendipity_property_bag;
                $plugin->introspect($bag);

                if ($bag->get('rewrite_active') === true) {

                    // Store necessary data in our main container
                    $serendipity['content_rewrite']['string'] = $plugin->get_config('rewrite_string');

                    if ($serendipity['content_rewrite']['string'] != '') {
                        $rewrite_from = $bag->get('rewrite_from');
                        $serendipity['content_rewrite']['data']['rewrite_char'][$serendipity['content_rewrite']['string']] = &$plugin->get_config('rewrite_char');

                        foreach($rewrite_from AS $nr => $key) {
                            $serendipity['content_rewrite']['data']['rewrite_from'][$serendipity['content_rewrite']['string']][] = $plugin->get_config($key);
                        }

                        $rewrite_to = $bag->get('rewrite_to');
                        foreach($rewrite_to AS $nr => $key) {
                            $serendipity['content_rewrite']['data']['rewrite_to'][$serendipity['content_rewrite']['string']][]   = $plugin->get_config($key);
                        }

                        // We now have at least one active plugin.
                        $serendipity['content_rewrite']['active'] = true;
                    }
                }
            }
        }
    }

    // Check if we have any plugin data needing rewrite
    if (is_array($serendipity['content_rewrite']['data']['rewrite_from'])) {
        foreach($serendipity['content_rewrite']['data']['rewrite_from'] AS $rewrite_string => $rewrite_values) {
            foreach($rewrite_values AS $key => $val) {
                if (trim($val) != '') {

                    // Use the supplied rewrite string and replace the {from} and {to} values with the ones we got from the plugin
                    $new =
                      str_replace(
                        array(
                          '{from}',
                          '{to}'
                        ),

                        array(
                          str_replace(
                            $serendipity['content_rewrite']['data']['rewrite_char'][$rewrite_string],
                            '',
                            $val
                          ),

                          $serendipity['content_rewrite']['data']['rewrite_to'][$rewrite_string][$key]
                        ),

                        $rewrite_string
                      );

                    // Build a regular expression (ungreedy, multiline) with our quoted value. $val here is the word needing the replacement
                    $regex = '([^\d\w])(' . preg_quote($val) . ')([^\d\w])msU';

                    // \1 and \3 are the prepend/append strings (usually whitespaces) and $new containing the new value
                    $str   = preg_replace($regex, '\1' . $new . '\3', $str);
                }
            }
        }
    }

    return $str;
}

function serendipity_markup_text($str, $entry_id = 0) {
    global $serendipity;

    $ret = $str;

    $ret = str_replace('\_', chr(1), $ret);
    $ret = preg_replace('/#([[:alnum:]]+?)#/','&\1;',$ret);
    $ret = preg_replace('/\b_([\S ]+?)_\b/','<u>\1</u>',$ret);
    $ret = str_replace(chr(1), '\_', $ret);

    // bold
    $ret = str_replace('\*',chr(1),$ret);
    $ret = str_replace('**',chr(2),$ret);
    $ret = preg_replace('/(\S)\*(\S)/','\1' . chr(1) . '\2',$ret);
    $ret = preg_replace('/\B\*([^*]+)\*\B/','<strong>\1</strong>',$ret);
    $ret = str_replace(chr(2),'**',$ret);
    $ret = str_replace(chr(1),'\*',$ret);

    // italics
    //$ret = str_replace('\~',chr(1),$ret);
    //$ret = preg_replace('/~([\S ]+?)~/','<i>\1</i>',$ret);
    //$ret = str_replace(chr(1),'\~',$ret);

    // monospace font
    $ret = str_replace('\%',chr(1),$ret);
    $ret = preg_replace_callback('/%([\S ]+?)%/', 'serendipity_format_tt', $ret);
    $ret = str_replace(chr(1),'%',$ret);

    $ret = preg_replace('/\|([0-9a-fA-F]+?)\|([\S ]+?)\|/','<font color="\1">\2</font>',$ret);
    $ret = preg_replace('/\^([[:alnum:]]+?)\^/','<sup>\1</sup>',$ret);
    $ret = preg_replace('/\@([[:alnum:]]+?)\@/','<sub>\1</sub>',$ret);
    $ret = preg_replace('/([\\\])([*#_|^@%])/', '\2', $ret);

    if ($serendipity['track_exits']) {
        $serendipity['encodeExitsCallback_entry_id'] = $entry_id;

        $ret = preg_replace_callback(
          "#<a(.*)href=(\"|')http://([^\"']+)(\"|')#isUm",
          'serendipity_encodeExitsCallback',
          $ret
        );
    }

    // Do some content rewrite, if necessary
    $ret = serendipity_content_rewrite($ret);

    return $ret;
}

/**
* Transforms '<a href="http://url/">' into
* '<a href="exit.php?url=encurl" ...>'.
*/
function serendipity_encodeExitsCallback($buffer) {
    global $serendipity;

    $entry_id = $serendipity['encodeExitsCallback_entry_id'];
    $url      = 'http://' . $buffer[3];

    return sprintf(
        '<a%shref="%sexit.php?url=%s%s" title="%s" onmouseOver="window.status=\'%s\';return true;" onmouseOut="window.status=\'\';return true;"',
        $buffer[1],
        $serendipity['baseURL'],
        base64_encode($url),
        ($entry_id != 0) ? '&amp;entry_id=' . $entry_id : '',
        $url,
        $url
    );
}

/**
* Transforms emoticons into images
*/
function serendipity_emoticate($str) {
    global $serendipity;

    foreach ($serendipity['smiles'] as $key => $value) {
        $str = preg_replace("/([\t\ ]?)" . preg_quote($key, '/') . "([\t\ \!\.\)]?)/m", "$1<img src=\"$value\" alt=\"$key\" style=\"display: inline; vertical-align: bottom;\" />$2", $str);
    }

    return $str;
}

/**
 * purge a statically pregenerated entry
 */
function serendipity_purgeEntry($id, $timestamp = null)
{
    global $serendipity;

    // If pregenerate is not set, short circuit all this logic
    // and remove nothing.
    if(!isset($serendipity['pregenerate'])) {
        return;
    }

    if (isset($timestamp)) {
        $dated = date('Ymd', $timestamp);
        $datem = date('Ym',  $timestamp);

        @unlink("{$serendipity['serendipityPath']}/archives/{$dated}.html");
        @unlink("{$serendipity['serendipityPath']}/archives/{$datem}.html");
    }

    // Fixme (the _* part) !
    @unlink("{$serendipity['serendipityPath']}/archives/{$id}_*.html");
    @unlink("{$serendipity['serendipityPath']}/feeds/index.rss");
    @unlink("{$serendipity['serendipityPath']}/feeds/index.rss2");
    @unlink("{$serendipity['serendipityPath']}/index.html");
}


/**
 * validate trackback response
 */
function serendipity_trackback_is_success($resp)
{
    if (preg_match('@<error>(\d)+</error>@', $resp, $matches)) {
        if ((int) $matches[1]) {
            return 1;
        } else {
            if (preg_match('@<message>([^<]+)</message>@', $resp, $matches)) {
                return $matches[1];
            }
            else {
                return 'unknown error';
            }
        }
    }
    return 1;
}

function serendipity_pingback_autodiscover($loc, $body) {
    if($_SERVER['X-PINGBACK']) {
        $pingback = $_SERVER['X-PINGBACK'];
    } else if(preg_match('@<link rel="pingback" href="([^"]+)" ?/?>@i', $body, $matches)) {
        $pingback = $matches[1];
    } else {
        return;
    }

    // xml-rpc hack
    $query = "
<?xml version=\"1.0\"?>
<methodCall>
  <methodName>pingback.ping</methodName>
  <params>
    <param>
      <name>sourceURI</name>
      <value><string>http://{$_SERVER['HTTP_HOST']}{$serendipity['baseURL']}</string></value>
    </param>
      <name>targetURI</name>
      <value><string>$loc</string></value>
    </param>
  </params>
</methodCall>";
        _serendipity_send($pingback, $query);
        return;
}

/**
 * Send a trackback ping
 */
function _serendipity_send($loc, $data) {
    global $serendipity;
    $target = parse_url($loc);
    if ($target['query'] != '') {
        $target['query'] = '?' . $target['query'];
    }

    if (!is_numeric($target['port'])) {
       $target['port'] = 80;
    }

    $sock = fsockopen($target['host'], $target['port']);
    if (!is_resource($sock)) {
        return "Couldn't connect to $loc";
    }

    fwrite($sock, "POST {$target['path']}{$target['query']} HTTP/1.1\r\n");
    fwrite($sock, "Host: {$target['host']}\r\n");
    fwrite($sock, "User-Agent: Serendipity/{$serendipity['version']}\r\n");
    fwrite($sock, "Content-type: application/x-www-form-urlencoded\r\n");
    fwrite($sock, "Content-length: " . strlen($data) . "\r\n");
    fwrite($sock, "Connection: close\r\n\r\n");
    fwrite($sock, $data);

    while (!feof($sock)) {
        $res .= fgets($sock, 1024);
    }

    fclose($sock);
    return $res;
}

function serendipity_trackback_autodiscover($res, $loc, $url, $author, $title, $text)
{
    if(!preg_match('@trackback:ping(\s*rdf:resource)?\s*=\s*"(http:[^"]+)"@i', $res, $matches)) {
        return;
    }

    if (preg_match('@dc:identifier\s*=\s*"(http:[^"]+)"@i', $res, $test)) {
        if ($loc != $test[1]) {
            return;
        }
    }

    $data = 'url='        . rawurlencode($url)
          . '&title='     . rawurlencode($title)
          . '&blog_name=' . rawurlencode($author)
          . '&excerpt='   . rawurlencode(strip_tags($text));

    $response = serendipity_trackback_is_success(_serendipity_send($matches[2], $data));
    return $response;
}

function serendipity_reference_autodiscover($loc, $url, $author, $title, $text) {
    $res = @file_get_contents($loc);
    if ( strlen($res) != 0 ) {
        serendipity_trackback_autodiscover($res, $loc, $url, $author, $title, $text);
        serendipity_pingback_autodiscover($loc, $res);
    }
}

/**
 *
 */
function add_trackback ($id, $title, $url, $name, $excerpt)
{
    global $serendipity;

    // We can't accept a trackback if we don't get any URL
    // This is a protocol rule.
    if ( empty($url) ) {
        return 0;
    }

    // If title is not provided, the value for url will be set as the title
    // This is a protocol rule.
    if ( empty($title) ) {
        $title = $url;
    }
    $comment['title']   = $title;
    $comment['url']     = $url;
    $comment['name']    = $name;
    $comment['comment'] = $excerpt;

    serendipity_saveComment($id, $comment, 'TRACKBACK');

    return 1;
}

function add_pingback ($id, $postdata)
{
    global $serendipity;

    if(preg_match('@<methodcall>\s*<methodName>\s*pingback.ping\s*</methodName>\s*<params>\s*<param>\s*<value>\s*<string>([^<])*</string>\s*</value>\s*</param>\s*<param>\s*<value>\s*<string>([^<])*</string>\s*</value>\s*</param>\s*</params>\s*</methodCall>@i', $postdata, $matches)) {
        $remote             = $matches[1];
        $local              = $matches[2];
        $comment['title']   = '';
        $comment['url']     = $remote;
        $comment['comment'] = '';
        $comment['name']    = '';

        serendipity_saveComment($id, $comment, 'PINGBACK');
        return 1;
    }
    return 0;
}

/**
 * Cut text
 */
function serendipity_trackback_excerpt($text)
{
    return substr($text, 0, 255);
}

function report_trackback_success ()
{
print '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
print <<<SUCCESS
<response>
    <error>0</error>
</response>
SUCCESS;
}

function report_trackback_failure ()
{
print '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
print <<<FAILURE
<response>
    <error>1</error>
    <message>Danger Will Robinson, trackback failed.</message>
</response>
FAILURE;
}

function report_pingback_success ()
{
print '<?xml version="1.0"?>' . "\n";
print <<<SUCCESS
<methodResponse>
   <params>
      <param>
         <value><string>success</string></value>
         </param>
      </params>
   </methodResponse>
SUCCESS;
}

function report_pingback_failure ()
{
print '<?xml version="1.0"?>' . "\n";
print <<<FAILURE
<methodResponse>
    <fault>
    <value><i4>0</i4></value>
    </fault>
</methodResponse>
FAILURE;
}

/**
 * return a fully qualified URL
 */
function serendipity_archiveURL($id, $title, $key = 'baseURL') {
global $serendipity;

    return $serendipity[$key] . 'archives/' . $id . '_' . serendipity_makeFilename($title) . '.html';
}

/**
 * search through link body, and automatically send a trackback ping.
 */
function serendipity_handle_references($id, $author, $title, $text)
{
    global $serendipity;

    if (!preg_match_all('@<a[^>]+?href\s*=\s*["\']?([^\'" >]+?)[ \'"]?>([^<]*)</a>@i', $text, $matches)) {
        return;
    }

    // remove full matches
    array_shift($matches);

    // Make trackback URL
    $url = serendipity_archiveURL($id, $title);

    // Add URL references
    $locations = $matches[0];
    $names = $matches[1];
    $tmpid = serendipity_db_escape_string($id);

    for ($i = 0, $j = count($locations); $i < $j; ++$i) {
        if($locations[$i][0] == '/') {
            $locations[$i] = 'http://' . $_SERVER['HTTP_HOST'] . $locations[$i];
        }

        $query = "SELECT COUNT(id) FROM {$serendipity['dbPrefix']}references WHERE ";
        $query .= "entry_id=$tmpid AND link='" . serendipity_db_escape_string($locations[$i]) . "'";

        $row = serendipity_db_query($query, true, 'num');
        if ($row[0] > 0) {
            continue;
        }
        if (!$serendipity['noautodiscovery']) {
            serendipity_reference_autodiscover($locations[$i], $url, $author, $title, serendipity_trackback_excerpt($text));
        }
    }
    serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}references WHERE entry_id='$tmpid'");

    for ($i = 0; $i < $j; ++$i) {
        $query = "INSERT INTO {$serendipity['dbPrefix']}references (entry_id, name, link) VALUES(";
        $query .= "'$tmpid', '" . serendipity_db_escape_string($names[$i]) . "', '";
        $query .= serendipity_db_escape_string($locations[$i]) . "')";

        serendipity_db_query($query);
    }

    // Add citations
    preg_match_all('@<cite[^>]*>([^<]+)</cite>@i', $text, $matches);

    foreach ($matches[1] as $citation) {
        $query = "INSERT INTO {$serendipity['dbPrefix']}references (entry_id, name) VALUES(";
        $query .= "'$tmpid', '" . serendipity_db_escape_string($citation) . "')";

        serendipity_db_query($query);
    }
}

/**
* Inserts a new entry into the database or updates an existing
**/
function serendipity_updertEntry($entry) {
    global $serendipity;

    $newEntry = 0;
    $exflag = 0;

    if (!is_numeric($entry['timestamp'])) {
        $entry['timestamp'] = time();
    }

    if(strlen($entry['extended'])) {
        $exflag = 1;
    }

    $entry['exflag']   = $exflag;
    $entry['author']   = $serendipity['user'];
    $entry['authorid'] = $serendipity['authorid'];

    if (!is_numeric($entry['id'])) {
        /* we need to insert */

        unset($entry['id']);
        $entry['comments'] = 0;

        $res = serendipity_db_insert('entries', $entry);

        if ($res)
            $entry['id'] = serendipity_db_insert_id();
        else {
            //Some error message here
            return ENTRIES_NOT_SUCCESSFULLY_INSERTED;
        }
        $newEntry    = 1;
    } else {
        /* we need to update */

        $res = serendipity_db_update('entries', array('id' => $entry['id']), $entry);
        $newEntry = 0;
    }

    if (is_string($res)) {
        return $res;
    }

    if ( $entry['isdraft'] == 'false' ) {
        serendipity_handle_references($entry['id'], $serendipity['blogTitle'], $entry['title'], $entry['body'] . $entry['extended'], $newEntry);
    }

    serendipity_purgeEntry($entry['id'], $entry['timestamp']);

    return (int)$entry['id'];
}

/**
* Deletes an entry and everything that belongs to it (comments, etc...) from
* the database
**/
function serendipity_deleteEntry($id) {
    global $serendipity;

    if (!is_numeric($id)) {
        return false;
    }

    // Purge the daily/monthly entries so they can be rebuilt
    $result = serendipity_db_query("SELECT timestamp FROM {$serendipity['dbPrefix']}entries WHERE id=$id", true);
    serendipity_purgeEntry($id, $result[0]);

    serendipity_db_query("DELETE FROM {$serendipity["dbPrefix"]}entries WHERE id=$id");

    serendipity_db_query("DELETE FROM {$serendipity["dbPrefix"]}comments WHERE entry_id=$id");

    serendipity_db_query("DELETE FROM {$serendipity['dbPrefix']}references WHERE entry_id='$id'");
}


/**
* Get a list of images
**/
function serendipity_fetchImages($group = false, $start = 0, $end = 20) {
    global $serendipity;

    if (count($serendipity['imageList'])) {
        return;
    }

    // Open directory
    if ($dir = @opendir($serendipity['serendipityPath'] . $serendipity['uploadPath'])) {
        while(false !== ($f = readdir($dir))) {
            if ($f != '.' && $f != '..' && strpos($f, $serendipity['thumbSuffix']) === false) {
                array_push($serendipity['imageList'], $f);
            }
        }
    }

    natsort($serendipity['imageList']);
}

/**
* Split up a filename
**/
function serendipity_parseFileName($file) {
    $x = explode('.', $file);
    $suf = array_pop($x);
    $f   = @implode('.', $x);
    return array($f, $suf);
}

function serendipity_resize_image_gd($infilename, $outfilename, $newwidth, $newheight=null)
{
    if (!function_exists('imagecopyresampled')) {
        return false;
    }

    $inf = pathinfo(strtolower($infilename));
    switch ($inf['extension']) {
        case 'gif':
            $loadfn = 'imagecreatefromgif';
            $savefn = 'imagegif';
            break;

        case 'jpeg':
        case 'jpg':
        case 'jfif':
            $loadfn = 'imagecreatefromjpeg';
            $savefn = 'imagejpeg';
            break;

        case 'png':
            $loadfn = 'imagecreatefrompng';
            $savefn = 'imagepng';
            break;

        default:
            return false;
    }

    /* If our loader does not exist, we are doomed */
    if ( !function_exists($loadfn) ) {
        return false;
    }

    /* If the save function does not exist (i.e. read-only GIF), we want to output it as PNG */
    if ( !function_exists($savefn) ) {
        if ( function_exists('imagepng') ) {
            $savefn = 'imagepng';
        } else {
            return false;
        }
    }

    $in = $loadfn($infilename);
    if (is_null($newheight)) {
        $newheight = (imagesy($in) / imagesx($in)) * $newwidth;
    }
    $out = imagecreatetruecolor($newwidth, $newheight);
    imagecopyresampled($out, $in, 0, 0, 0, 0, $newwidth, $newheight, imagesx($in), imagesy($in));
    $savefn($out, $outfilename);
    $out = null;
    $in  = null;

    return 'OK!';
}

/**
* Generate a thumbnail
**/
function serendipity_makeThumbnail($file, $size=false) {
    global $serendipity;

    if ($size===false) {
        $size = $serendipity['thumbSize'];
    }

    // Calculate name of thumbnail
    $t = serendipity_parseFileName($file);
    $f = $t[0];
    $suf = $t[1];

    $infile  = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file;
    $outfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $f . '.' . $serendipity['thumbSuffix'] . '.' . $suf;

    if ($serendipity['magick'] !== true) {
        return serendipity_resize_image_gd($infile, $outfile, $size);
    }

    /*if ($serendipity["dim"] == "height") $newSize = "*x".$serendipity["thumbSize"];
    else $newSize = $serendipity["thumbSize"]."x*"; */
    $newSize = $size . 'x' . $size;
    $cmd     = $serendipity['convert'] . " -antialias -scale $newSize $infile $outfile  2>&1";
    $res     = `$cmd`;

    return $res;
}

/**
*  Scale an image (ignoring proportions)
**/
function serendipity_scaleImg($file, $width, $height) {
    global $serendipity;

    $infile = $outfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $file;

    if($serendipity['magick'] !== true) {
        return serendipity_resize_image_gd($infile, $outfile, $width, $height);
    }

    $cmd = $serendipity['convert'] . ' -scale ' .  $width . 'x' . $height . ' ' . $infile . ' ' . $outfile;
    $res = `$cmd`;
    return $res;
}

/**
* Creates thumbnails for all images in the upload dir
**/
function serendipity_generateThumbs() {
    global $serendipity;

    $i=0;
    serendipity_fetchImages();

    $files = $serendipity['imageList'];
    for($x=0; $x<count($files); $x++) {
        $f = serendipity_parseFileName($files[$x]);
        $fdim = getimagesize($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $files[$x]);

        $checkfile = $serendipity['serendipityPath'] . $serendipity['uploadPath'] . $f[0] . '.' . $serendipity['thumbSuffix'] . '.' . $f[1];

        if (!file_exists($checkfile) && ($fdim[0] > $serendipity['thumbSize'] || $fdim[1] > $serendipity['thumbSize'])) {
            printf(RESIZE_BLAHBLAH, $files[$x] . ': ' . serendipity_makeThumbnail($files[$x]));
            $i++;
        } elseif (!file_exists($checkfile) && $fdim[0] < $serendipity['thumbSize'] && $fdim[1] < $serendipity['thumbSize']) {
            $res = copy ($serendipity['serendipityPath'] . $serendipity['uploadPath'] . $files[$x], $checkfile);
            if ($res === true) {
                printf(THUMBNAIL_USING_OWN . '<br />', $files[$x]);
            } else {
                printf('<span style="color: #ff0000">' . THUMBNAIL_FAILED_COPY . '</span><br />', $files[$x]);
            }
        }
    }

    return $i;
}

/**
* Prints a form to enter new diary entries
**/
function serendipity_printEntryForm($targetURL, $hiddens = array(), $entry = array(), $errMsg = "") {
    global $serendipity;

    $serendipity['EditorBrowsers'] = '(IE|Mozilla)';
    $cats = serendipity_fetchCategories();

    $draftD = '';
    $draftP = '';

    if (isset($entry['isdraft']) && $entry['isdraft'] == 'true') {
        $draftD = ' selected="selected"';
    } else {
        $draftP = ' selected="selected"';
    }

    if (isset($entry['allow_comments']) && ($entry['allow_comments'] == 'true' || $entry['allow_comments'] === true)) {
        $allow_comments = ' checked="checked"';
    } elseif ($entry['allow_comments'] != 'false' && $entry['allow_comments'] !== 'false' && ($serendipity['allowCommentsDefault'] == 'true' || $serendipity['allowCommentsDefault'] === true)) {
        $allow_comments = ' checked="checked"';
    } else {
        $allow_comments = '';
    }

    $n = "\n";
    $cat_list = '<select name="serendipity[categoryid]">' . $n;
    $cat_list .= '    <option value="0">[' . NO_CATEGORY . ']</option>' . $n;
    if (is_array($cats)) {
        foreach ($cats as $cat_data) {
            $selected = (isset($entry['categoryid']) && $cat_data['categoryid'] == $entry['categoryid'] ? ' selected="selected"' : '');
            $cat_list .= '    <option value="' . $cat_data['categoryid'] . '" ' . $selected . '>'
                       . htmlentities($cat_data['category_name'])
                       . ' - '
                       . htmlentities($cat_data['category_description'])
                       . '</option>' . $n;
        }
    }
    $cat_list .= '</select>' . $n;

    $hidden = '';
    foreach($hiddens as $key => $value) {
        $hidden .= '        <input type="hidden" name="' . $key . '" value="' . $value . '" />' . $n;
    }
    $hidden .= '        <input type="hidden" name="serendipity[id]" value="' . (isset($entry['id']) ? $entry['id'] : '') . '" />' . $n;
    $hidden .= '        <input type="hidden" name="serendipity[timestamp]" value="' . (isset($entry['timestamp']) ? $entry['timestamp'] : '') . '" />' . $n;
    $hidden .= '        <input type="hidden" name="serendipity[preview]" value="false" />';
?>
        <span style="color: #FF0000;"><?php echo $errMsg; ?></span>
        <form action="<?php echo $targetURL; ?>" method="post" <?php echo ($serendipity['XHTML11'] ? 'id' : 'name'); ?>="serendipityEntry" style="margin-top: 0px; margin-bottom: 0px; padding-top: 0px; padding-bottom: 0px">
        <?php echo $hidden; ?>

        <table class="serendipityEntryEdit" border="0">
            <tr>
                <td>
                   <b><?php echo TITLE; ?>:</b>
                </td>
                <td colspan="2">
                    <table width="100%" cellspacing="0" cellpadding="0" border="0">
                        <tr>
                            <td><input type="text" name="serendipity[title]" value="<?php echo isset($entry['title']) ? htmlentities($entry['title']) : ''; ?>" size="72" /></td>
                            <td align="right"><select name="serendipity[isdraft]">
                                <option  value="false" <?php echo $draftP; ?>><?php echo PUBLISH; ?></option>
                                <option  value="true"  <?php echo $draftD; ?>><?php echo DRAFT; ?></option>
                                </select>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
<?php
        if (isset($serendipity['allowDateManipulation']) && $serendipity['allowDateManipulation']) {
?>
                <td>
                    <b><?php echo DATE; ?>:</b>
                </td>
                <td>
                    <input type="hidden" name="serendipity[chk_timestamp]" value="<?php echo (isset($entry['timestamp']) && $entry['timestamp'] > 0 ? $entry['timestamp'] : time()); ?>" />
                    <input type="text" name="serendipity[new_timestamp]" value="<?php echo date(DATE_FORMAT_2, (isset($entry['timestamp']) && $entry['timestamp'] > 0 ? $entry['timestamp'] : time())); ?>" />
                </td>
                <td align="right">
<?php
        } else {
?>
                <td align="right" colspan="3">
<?php
        }
?>
                    <b><?php echo CATEGORY; ?></b> <?php echo $cat_list ; ?></td>
            </tr>
            <tr>
<?php
    if (!$serendipity['wysiwyg']) {
?>
                <td colspan="2"><b><?php echo ENTRY_BODY; ?></b></td>
                <td align="right">
<?php
        /* Since the user has WYSIWYG editor disabled, we want to check if we should use the "better" non-WYSIWYG editor */
        if (!$serendipity['wysiwyg'] && eregi($serendipity['EditorBrowsers'], $_SERVER['HTTP_USER_AGENT']) ) {
?>
                        <input type="button" name="insI" value="I" accesskey="i" style="font-style: italic" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<i>','</i>')" />
                        <input type="button" name="insB" value="B" accesskey="i" style="font-weight: bold" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<b>','</b>')" />
                        <input type="button" name="insU" value="U" accesskey="u" style="text-decoration: underline;" onclick="wrapSelection(document.forms['serendipityEntry']['serendipity[body]'],'<u>','</u>')" />
                        <input type="button" name="insJ" value="img" accesskey="j" onclick="wrapInsImage(document.forms['serendipityEntry']['serendipity[body]'])" />
                        <input type="button" name="insImage" value="<?php echo IMAGE ; ?>" style="" onclick="window.open('serendipity_admin_image_selector.php', 'ImageSel', 'width=800, height=600, toolbar=no');" />
                        <input type="button" name="insU" value="URL" accesskey="l" style="color: blue; text-decoration: underline;" onclick="wrapSelectionWithLink(document.forms['serendipityEntry']['serendipity[body]'])" />
<?php
        /* Do the "old" non-WYSIWYG editor */
        } elseif (!$serendipity['wysiwyg']) { ?>
                        <input type="button" value=" B " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'b')">
                        <input type="button" value=" U " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'u')">
                        <input type="button" value=" I " onclick="serendipity_insBasic(document.forms['serendipityEntry']['serendipity[body]'], 'i')">
                        <input type="button" value="<img>" onclick="serendipity_insImage(document.forms['serendipityEntry']['serendipity[body]'])">
                        <input type="button" value="<?php echo IMAGE; ?>" onclick="window.open('serendipity_admin_image_selector.php', 'ImageSel', 'width=800,height=600,toolbar=no');">
                        <input type="button" value="Link" onclick="serendipity_insLink(document.forms['serendipityEntry']['serendipity[body]'])">
<?php   }
    } else {
?>
            <td colspan="3"><b><?php echo ENTRY_BODY; ?></b>

<?php } ?>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <textarea name="serendipity[body]" id="serendipity[body]" cols="80" rows="20"><?php echo isset($entry['body']) ? htmlentities($entry['body']) : ''; ?></textarea>
                </td>
            </tr>

            <tr>
                <td colspan="3">
                    <table width="100%" cellpadding="0" cellspacing="0">
                        <tr>
                            <td align="left">
                                <input id="checkbox_allow_comments" type="checkbox" name="serendipity[allow_comments]" value="true" <?php echo $allow_comments; ?> /><label for="checkbox_allow_comments"><?php echo COMMENTS_ENABLE; ?></label>
                            </td>

                            <td align="right">
                                <input type="button" value="- <?php echo PREVIEW; ?> -" style="font-weight: bold;" onclick="document.forms['serendipityEntry'].elements['serendipity[preview]'].value='true'; document.forms['serendipityEntry'].submit();" />
                                <input type="submit" value="- <?php echo SAVE; ?> -" style="font-weight: bold;" />
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>

            <tr>
                <td colspan="3"><b><?php echo EXTENDED_BODY; ?></b></td>
            </tr>

            <tr>
                <td colspan="3">
                    <textarea name="serendipity[extended]" id="serendipity[extended]" cols="80" rows="20"><?php echo isset($entry['extended']) ? htmlentities($entry['extended']) : ''; ?></textarea>
                </td>
            </tr>
        </table>
    </form>
<?php
    if ($serendipity['wysiwyg']) {
        serendipity_emit_htmlarea_code('document.forms[\'serendipityEntry\'][\'serendipity[body]\']');
        serendipity_emit_htmlarea_code('document.forms[\'serendipityEntry\'][\'serendipity[extended]\']');
    } else {
        echo '    <script type="text/javascript" language="JavaScript" src="serendipity_define.js.php"></script>';
        echo '    <script type="text/javascript" language="JavaScript" src="serendipity_editor.js"></script>';
    }
}

function serendipity_authenticate_author($username, $password) {
    global $serendipity;

    if (isset($_SESSION['serendipityUser']) && isset($_SESSION['serendipityEmail']) && isset($_SESSION['serendipityAuthorid']) && isset($_SESSION['serendipityAuthedUser']) && $_SESSION['serendipityAuthedUser'] == true) {
        $serendipity['serendipityUser']  = $_SESSION['serendipityUser'];
        $serendipity['serendipityEmail'] = $_SESSION['serendipityEmail'];
        $serendipity['authorid']         = $_SESSION['serendipityAuthorid'];
        return true;
    }

    $password = md5($password);

    $query = "SELECT DISTINCT
                email, authorid
              FROM
                $serendipity[dbPrefix]authors
              WHERE
                username = '$username'
              AND password = '$password'";
    $row = serendipity_db_query($query, true, 'assoc');

    if (is_string($row)) {
        print $row;
    }

    if ($row) {
        $_SESSION['serendipityUser']     = $serendipity['serendipityUser']  = $username;
        $_SESSION['serendipityEmail']    = $serendipity['serendipityEmail'] = $row['email'];
        $_SESSION['serendipityAuthorid'] = $serendipity['authorid']         = $row['authorid'];
        return true;
    }

    return false;
}

function serendipity_track_referrer($entry = 0) {
    global $serendipity;

    if (isset($_SERVER['HTTP_REFERER'])) {
        if (stristr($_SERVER['HTTP_REFERER'], $serendipity['baseURL']) !== false) {
            return;
        }

        if (!isset($serendipity['_blockReferer']) || !is_array($serendipity['_blockReferer'])) {
            // Only generate an array once per call
            $serendipity['_blockReferer'] = array();
            $serendipity['_blockReferer'] = @explode(';', $serendipity['blockReferer']);
        }

        $url_parts  = parse_url($_SERVER['HTTP_REFERER']);
        $host_parts = explode('.', $url_parts['host']);
        if (!$url_parts['host'] ||
            strstr($url_parts['host'], $_SERVER['SERVER_NAME'])) {
            return;
        }

        foreach($serendipity['_blockReferer'] AS $idx => $hostname) {
            if (@strstr($url_parts['host'], $hostname)) {
                return;
            }
        }

        if (rand(0, 100) < 1) {
            serendipity_track_referrer_gc();
        }
        if($serendipity['dbType'] == "mysql")
            $interval = 900;
        else
            $interval = "interval '900'";

        $suppressq = "SELECT count(1)
                      FROM $serendipity[dbPrefix]suppress
                      WHERE ip = '$_SERVER[REMOTE_ADDR]'
                      AND scheme = '$url_parts[scheme]'
                      AND port = '$url_parts[port]'
                      AND host = '$url_parts[host]'
                      AND path = '$url_parts[path]'
                      AND query = '$url_parts[query]'
                      AND last > now() - $interval";

        $suppressp = "DELETE FROM $serendipity[dbPrefix]suppress
                      WHERE ip = '$_SERVER[REMOTE_ADDR]'
                      AND scheme = '$url_parts[scheme]'
                      AND host = '$url_parts[host]'
                      AND port = '$url_parts[port]'
                      AND query = '$url_parts[query]'
                      AND path = '$url_parts[path]'";
        $suppressu = "INSERT INTO $serendipity[dbPrefix]suppress
                      (ip, last, scheme, host, port, path, query)
                      VALUES ('$_SERVER[REMOTE_ADDR]', now(), '$url_parts[scheme]', '$url_parts[host]', '$url_parts[port]', '$url_parts[path]', '$url_parts[query]')";

        $count = serendipity_db_query($suppressq, true);

        if ($count[0] == 0) {
            serendipity_db_query($suppressu);
            return;
        }

        serendipity_db_query($suppressp);
        serendipity_db_query($suppressu);

        serendipity_track_url('referrers', $_SERVER['HTTP_REFERER'], $entry);
    }
}

function serendipity_track_referrer_gc() {
    global $serendipity;

    if($serendipity['dbType'] == "mysql")
        $interval = 900;
    else
        $interval = "interval '900'";

    $gc = "DELETE FROM $serendipity[dbPrefix]suppress where last < now() = $interval";
    serendipity_db_query($gc);
}

function serendipity_track_url($list, $url, $entry_id = 0) {
    global $serendipity;

    $url_parts = parse_url($url);

    serendipity_db_query(
      @sprintf(
        "UPDATE %s
            SET count = count + 1
          WHERE scheme = '%s'
            AND host   = '%s'
            AND port   = '%s'
            AND path   = '%s'
            AND query  = '%s'
            AND day    = NOW()
                %s",

        $serendipity['dbPrefix'] . $list,
        $url_parts['scheme'],
        $url_parts['host'],
        $url_parts['port'],
        $url_parts['path'],
        $url_parts['query'],
        ($entry_id != 0) ? "AND entry_id = '$entry_id'" : ''
      )
    );

    if (serendipity_db_affected_rows() == 0) {
        serendipity_db_query(
          sprintf(
            "INSERT INTO %s
                    (day, count, scheme, host, port, path, query%s)
             VALUES ( NOW(), 1, '%s', '%s', '%s', '%s', '%s'%s)",
            $serendipity['dbPrefix'] . $list,
            ($entry_id != 0) ? ', entry_id' : '',
            $url_parts['scheme'],
            $url_parts['host'],
            $url_parts['port'],
            $url_parts['path'],
            $url_parts['query'],
            ($entry_id != 0) ? ", '$entry_id'" : ''
          )
        );
    }
}

function serendipity_displayTopReferrers($limit = 10) {
    serendipity_displayTopUrlList('referrers', $limit);
}

function serendipity_displayTopExits($limit = 10) {
    serendipity_displayTopUrlList('exits', $limit);
}

function serendipity_displayTopUrlList($list, $limit) {
    global $serendipity;

    $query = "SELECT host, SUM(count) AS total
              FROM {$serendipity['dbPrefix']}$list
              GROUP BY host
              ORDER BY total DESC, host
              LIMIT $limit";

    $rows = serendipity_db_query($query);
    echo "<span class='serendipityReferer'>";
    if (is_array($rows)) {
        foreach ($rows as $row) {
            printf(
                '<a href="http://%1$s" title="%1$s" >%1$s</a> (%2$s)<br />',
                $row['host'],
                $row['total']
            );
        }
    }
    echo "</span>";
}

function serendipity_emit_htmlarea_code($item)
{
    static $init = false;
    global $serendipity;

    if (isset ($serendipity['wysiwyg']) && $serendipity['wysiwyg']) {

        if (!$init) {
?>
    <script type="text/javascript" src="htmlarea/htmlarea.js"></script>
    <script type="text/javascript" src="htmlarea/htmlarea-lang-en.js"></script>
    <script type="text/javascript" src="htmlarea/dialog.js"></script>
    <style  type="text/css">@import url(htmlarea/htmlarea.css);</style>
<?php
        }

        echo '<script defer="defer">(new HTMLArea(' . $item . ')).generate();</script>';
    }

    $init = true;
}

function serendipity_updateEntryCategories($postid, $categories) {
    global $serendipity;

    if(!$postid || !$categories) {
        return;
    }
    $query = "UPDATE $serendipity[dbPrefix]entries set categoryid = $categories[0] where id = $postid";
    $err = serendipity_db_query($query);

    /* TODO: nuke this */
    $fp = fopen('/tmp/a', 'w');
    fwrite($fp,$query);
    if(is_string($err)) {
        fwrite($fp, $err);
    }
    fclose($fp);
}

/*
* Amount of posts for given year & month
*/
function serendipity_postAmount($year, $month) {
    global $serendipity;

    $s = mktime(0, 0, 0, $month, 1, $year);
    $e = mktime(23, 59, 59, $month, date('t', $s), $year);
    $querystring = "SELECT count(id) FROM {$serendipity['dbPrefix']}entries WHERE timestamp >= $s AND timestamp <= $e";
    $query = serendipity_db_query($querystring);

    return $query[0][0];
}

/*
* Print the archive
*/
function serendipity_printArchives() {
    global $serendipity;

    echo '<div class="serendipity_title">' . ARCHIVES . '</div>';

    $f = serendipity_db_query("SELECT timestamp FROM {$serendipity['dbPrefix']}entries ORDER BY timestamp ASC LIMIT 1");
    $lastYear = date('Y', $f[0][0]);
    $lastMonth= date('m', $f[0]);
    $currYear = date('Y');
    $max = 0;

    while($currYear >= $lastYear) {
         // echo "<h2>$currYear</h2><div class='serendipity_entry'>";
         for($x=1; $x<13; $x++) {
            $entries = serendipity_postAmount($currYear, $x);
            if ($entries > 0) {
                    $a = "<a href='{$serendipity['serendipityHTTPPath']}archives/$currYear" . sprintf('%02s', $x) . '.html\'>';
                    $b = '</a>';
                    $c = "<a href='{$serendipity['serendipityHTTPPath']}archives/$currYear" . sprintf('%02s', $x) . '_short.html\'>';
                    $d = "<a href='{$serendipity['serendipityHTTPPath']}archives/$currYear" . sprintf('%02s', $x) . '.html\'>';
            } else {
                $a = $c = '<span style="color: #CDCDCD">';
                $b = $d = '</span>';
            }

            if ($x <= date('m') || $currYear < date('Y')) {
                $out[$currYear][$x] = array($entries, $a, $b, $c, $d);
            }

            if ($entries > $max) {
                $max = $entries;
            }
         }
         // echo "</div>";
         $currYear--;
    }

    if (!$max) {
        return;
    }

    $barwidth = 40;
    $fac = $barwidth/$max;
?>
<table cellspacing="0">
<?php
    foreach($out as $year => $months) {
?>
    <tr>
        <td colspan="4"><h2><?php echo $year; ?></h2></td>
    </tr>
<?php
        for($y=1; $y<13; $y++) {
            if (isset($months[$y]) && $months[$y]) {
?>
    <tr>
        <td>
            <img src="<?php echo $serendipity['serendipityHTTPPath']; ?>pixel/bar1.png"  height="10" width="<?php echo ceil($months[$y][0]*$fac); ?>"             hspace="0" vspace="0" alt="" />
            <img src="<?php echo $serendipity['serendipityHTTPPath']; ?>pixel/blank.png" height="10" width="<?php echo ($barwidth-ceil($months[$y][0]*$fac)); ?>" hspace="0" vspace="0" alt="" />
                 &nbsp;&nbsp;<?php echo $months[$y][1] . $serendipity['months'][$y] . $months[$y][2] . ' (' . $months[$y][0] . ' ' . ENTRIES . ')'; ?>
        </td>

        <td>
            <img src="<?php echo $serendipity['serendipityHTTPPath']; ?>pixel/blank.png" height="10" width="35" hspace="0" vspace="0" alt="" />
                (<?php echo $months[$y][1] . VIEW_FULL . $months[$y][2]; ?>)
        </td>

        <td>
            &nbsp;(<?php echo $months[$y][3] . VIEW_TOPICS . $months[$y][4]; ?>)
        </td>
    </tr>
<?php
            }
        }
    }
?>
</table>
<?php
}

function serendipity_xhtml_target($target)
{
    global $serendipity;

    if ($serendipity['XHTML11']) {
        return ' onclick="window.open(this.href, \'target' . time() . '\'); return false;" ';
    } else {
        return ' target="' . $target . '" ';
    }
}

define("serendipity_FUNCTIONS_LOADED", true);
/* vim: set sts=4 ts=4 expandtab : */
?>
